#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   OFLauncherDialog.py
#     OpenFOAMの設定をGUIで操作する為のDialogを表示。
#
#   10/01/03    新規作成
#   10/02/15    solverの起動を「plotWatcher & solve &」に変更。
#      02/21    boundaryの編集ボタン追加
#      04/08    Dialogのデザイン変更
#      04/25    並列計算追加
#      05/02    cpuモニタ追加
#

import os
import glob
import pyOFLauncher
import getFoamContents
import setFoamContents

CaseDir=""
dispCaseDir = ""
ShowFlag="show"
nameList=[]
frame_1 = ""
titleColor = ""


def Show():
    global frame_1, nameList, CaseDir, dispCaseDir, titleColor
    CaseDir = pyOFLauncher.readCurrentDirectory()
    dispCaseDir = changeLengthCaseDir(CaseDir)
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()

def changeLengthCaseDir(caseDir):
    maxLen = 75
    if len(caseDir) > maxLen:
        caseDir = "..." + caseDir[4-maxLen:]
    return caseDir

#
#   オリジナルに対し、変更なし。
#   -----------------------------------
#



# generated by wxGlade 0.6.3 on Sun Jan  3 10:42:44 2010
#
#

import wx

# begin wxGlade: extracode
# end wxGlade


class MyFrame(wx.Frame):
    global CaseDir, frame_1, nameList, dispCaseDir, titleColor
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.notebook_1 = wx.Notebook(self, -1, style=wx.NB_LEFT)
        self.notebook_1_pane_7 = wx.Panel(self.notebook_1, -1)
        self.notebook_1_pane_6 = wx.Panel(self.notebook_1, -1)
        self.notebook_1_pane_5 = wx.Panel(self.notebook_1, -1)
        self.panel_3 = wx.Panel(self.notebook_1_pane_5, -1)
        self.notebook_1_pane_4 = wx.Panel(self.notebook_1, -1)
        self.notebook_1_pane_3 = wx.Panel(self.notebook_1, -1)
        self.notebook_1_pane_2 = wx.Panel(self.notebook_1, -1)
        self.notebook_1_pane_1 = wx.Panel(self.notebook_1, -1)
        self.panel_2 = wx.Panel(self.notebook_1_pane_1, -1)
        self.panel_1 = wx.Panel(self.notebook_1_pane_1, -1)
        self.sizer_42_staticbox = wx.StaticBox(self.notebook_1_pane_1, -1, "")
        self.sizer_54_staticbox = wx.StaticBox(self.notebook_1_pane_1, -1, "")
        self.sizer_3_staticbox = wx.StaticBox(self.notebook_1_pane_1, -1, u"solver, 計算時間")
        self.sizer_24_staticbox = wx.StaticBox(self.notebook_1_pane_1, -1, u"現在のCase")
        self.sizer_7_staticbox = wx.StaticBox(self.notebook_1_pane_2, -1, u"変換方法の選択")
        self.sizer_8_staticbox = wx.StaticBox(self.notebook_1_pane_2, -1, u"メッシュのスケール変更")
        self.sizer_47_staticbox = wx.StaticBox(self.notebook_1_pane_2, -1, u"内部パッチの作成")
        self.sizer_48_staticbox = wx.StaticBox(self.notebook_1_pane_2, -1, u"メッシュの領域分割")
        self.sizer_10_staticbox = wx.StaticBox(self.notebook_1_pane_3, -1, u"boundaryFieldのクリア")
        self.sizer_31_staticbox = wx.StaticBox(self.notebook_1_pane_3, -1, u"patchの定義")
        self.sizer_11_staticbox = wx.StaticBox(self.notebook_1_pane_3, -1, u"boundaryFieldの編集")
        self.sizer_46_staticbox = wx.StaticBox(self.notebook_1_pane_4, -1, u"constantファイルの編集")
        self.sizer_51_staticbox = wx.StaticBox(self.notebook_1_pane_4, -1, u"systemファイルの編集")
        self.sizer_17_staticbox = wx.StaticBox(self.notebook_1_pane_4, -1, u"internalFieldのクリア")
        self.sizer_18_staticbox = wx.StaticBox(self.notebook_1_pane_4, -1, u"setFieldsDictの編集")
        self.sizer_22_staticbox = wx.StaticBox(self.notebook_1_pane_5, -1, "solver")
        self.sizer_25_staticbox = wx.StaticBox(self.notebook_1_pane_5, -1, u"編集")
        self.sizer_21_staticbox = wx.StaticBox(self.notebook_1_pane_5, -1, u"計算時間の設定")
        self.sizer_34_staticbox = wx.StaticBox(self.notebook_1_pane_5, -1, u"計算制御ファイルの編集")
        self.sizer_20_staticbox = wx.StaticBox(self.notebook_1_pane_5, -1, u"計算開始")
        self.sizer_58_staticbox = wx.StaticBox(self.notebook_1_pane_6, -1, u"設定ファイルの作成")
        self.sizer_59_staticbox = wx.StaticBox(self.notebook_1_pane_6, -1, u"並列計算")
        self.sizer_21_copy_staticbox = wx.StaticBox(self.notebook_1_pane_7, -1, u"結果の確認")
        self.sizer_4_copy_staticbox = wx.StaticBox(self.notebook_1_pane_7, -1, u"結果のVTK変換")
        self.sizer_35_staticbox = wx.StaticBox(self.notebook_1_pane_7, -1, u"電磁場解析結果の出力")
        self.sizer_23_staticbox = wx.StaticBox(self.notebook_1_pane_1, -1, u"Caseの作成")
        self.frame_1_statusbar = self.CreateStatusBar(1, 0)
        self.label_4 = wx.StaticText(self, -1, "OpenFOAM 1.6.x")
        self.label_5 = wx.StaticText(self, -1, "build at 2010/01/03")
        self.label_1 = wx.StaticText(self.notebook_1_pane_1, -1, u"solverの設定と計算方法")
        self.button_9 = wx.Button(self.notebook_1_pane_1, -1, u"Case作成")
        self.label_6 = wx.StaticText(self.notebook_1_pane_1, -1, u"新規にCaseを作成する。\ntutorialsから望みのsolverを使っているCaseをコピーする。")
        self.label_44 = wx.StaticText(self.notebook_1_pane_1, -1, u"  case名")
        self.label_42 = wx.StaticText(self.panel_1, -1, "case")
        self.label_45 = wx.StaticText(self.notebook_1_pane_1, -1, u"solver名")
        self.label_43 = wx.StaticText(self.panel_2, -1, "solver")
        self.button_19 = wx.Button(self.notebook_1_pane_1, -1, u"solver入替")
        self.label_8 = wx.StaticText(self.notebook_1_pane_1, -1, "")
        self.label_38 = wx.StaticText(self.notebook_1_pane_1, -1, u"メッシュを残したままsolverを入れ替える")
        self.label_9 = wx.StaticText(self.notebook_1_pane_1, -1, u"     計算:startTime -> endTime")
        self.label_2 = wx.StaticText(self.notebook_1_pane_1, -1, u"     書込:timeStep")
        self.label_46 = wx.StaticText(self.notebook_1_pane_1, -1, "    startFrom:")
        self.label_12 = wx.StaticText(self.notebook_1_pane_1, -1, "    startTime: ")
        self.label_27 = wx.StaticText(self.notebook_1_pane_1, -1, "      endTime: ")
        self.label_28 = wx.StaticText(self.notebook_1_pane_1, -1, "       deltaT: ")
        self.label_47 = wx.StaticText(self.notebook_1_pane_1, -1, " writeControl:")
        self.label_29 = wx.StaticText(self.notebook_1_pane_1, -1, "writeInterval: ")
        self.label_10 = wx.StaticText(self.notebook_1_pane_2, -1, u"メッシュ変換とスケール変更")
        self.button_1 = wx.Button(self.notebook_1_pane_2, -1, u"unv2gmshToFoam （VolumeとFaceをグループ化した場合）")
        self.button_3 = wx.Button(self.notebook_1_pane_2, -1, u"idearsUnvToFoam  （Faceのみグループ化した場合）    ")
        self.button_4 = wx.Button(self.notebook_1_pane_2, -1, "  transformPoints...  ")
        self.button_11 = wx.Button(self.notebook_1_pane_2, -1, u"作成...")
        self.label_35 = wx.StaticText(self.notebook_1_pane_2, -1, u"内部パッチ(internal patch)の作成")
        self.button_31 = wx.Button(self.notebook_1_pane_2, -1, u"cellZone結合")
        self.label_23 = wx.StaticText(self.notebook_1_pane_2, -1, u"cellZoneを結合します")
        self.button_32 = wx.Button(self.notebook_1_pane_2, -1, u"領域分割")
        self.label_36 = wx.StaticText(self.notebook_1_pane_2, -1, u"メッシュをcellZone毎に分割します")
        self.label_11 = wx.StaticText(self.notebook_1_pane_3, -1, u"境界条件の設定")
        self.button_5 = wx.Button(self.notebook_1_pane_3, -1, u"クリアする")
        self.label_13 = wx.StaticText(self.notebook_1_pane_3, -1, u"    全FieldのBoundaryField内に適用する\n    全Patchに「zeroGradient」を設定する")
        self.button_22 = wx.Button(self.notebook_1_pane_3, -1, u"boundary編集")
        self.label_30 = wx.StaticText(self.notebook_1_pane_3, -1, u"    patch の定義ファイルをEditorで編集する")
        self.button_6 = wx.Button(self.notebook_1_pane_3, -1, u"fileld編集")
        self.label_31 = wx.StaticText(self.notebook_1_pane_3, -1, u"    各Fieldの境界条件をEditorで編集する")
        self.label_14 = wx.StaticText(self.notebook_1_pane_4, -1, u"物性値データセット")
        self.button_2 = wx.Button(self.notebook_1_pane_4, -1, u"　Properties編集　")
        self.label_37 = wx.StaticText(self.notebook_1_pane_4, -1, u"constant内のファイルを編集する")
        self.button_23 = wx.Button(self.notebook_1_pane_4, -1, u"Dict編集")
        self.label_26 = wx.StaticText(self.notebook_1_pane_4, -1, u"system内のファイルを編集する")
        self.button_12 = wx.Button(self.notebook_1_pane_4, -1, u"クリアする")
        self.button_26 = wx.Button(self.notebook_1_pane_4, -1, u"Fieldの確認")
        self.label_15 = wx.StaticText(self.notebook_1_pane_4, -1, u"    全FieldのinternalFieldに適用　internalFieldに「0」を設定する\n")
        self.button_13 = wx.Button(self.notebook_1_pane_4, -1, u"編集する")
        self.label_25 = wx.StaticText(self.notebook_1_pane_4, -1, u"setFieldsDict をEditorで編集する")
        self.button_14 = wx.Button(self.notebook_1_pane_4, -1, u"データセット")
        self.button_27 = wx.Button(self.notebook_1_pane_4, -1, u"Fieldの確認")
        self.label_17 = wx.StaticText(self.notebook_1_pane_4, -1, u"    「setFields」コマンドでデータをセットする")
        self.label_18 = wx.StaticText(self.notebook_1_pane_5, -1, u"計算開始")
        self.label_39 = wx.StaticText(self.panel_3, -1, "icoFoam")
        self.button_40 = wx.Button(self.notebook_1_pane_5, -1, u"solver入替")
        self.button_24 = wx.Button(self.notebook_1_pane_5, -1, u"controlDict編集")
        self.label_20 = wx.StaticText(self.notebook_1_pane_5, -1, u"controlDictファイルの編集")
        self.button_25 = wx.Button(self.notebook_1_pane_5, -1, u"   fv...編集   ")
        self.label_24 = wx.StaticText(self.notebook_1_pane_5, -1, u"fvScheme, fvSolutionの編集")
        self.label_7 = wx.StaticText(self.notebook_1_pane_5, -1, "startFrom:")
        self.label_16 = wx.StaticText(self.notebook_1_pane_5, -1, "startTime:")
        self.label_21 = wx.StaticText(self.notebook_1_pane_5, -1, "endTime:")
        self.label_32 = wx.StaticText(self.notebook_1_pane_5, -1, "deltaT:")
        self.label_33 = wx.StaticText(self.notebook_1_pane_5, -1, "writeInterval:")
        self.combo_box_1 = wx.ComboBox(self.notebook_1_pane_5, -1, choices=["startTime", "latestTime"], style=wx.CB_DROPDOWN)
        self.text_ctrl_1 = wx.TextCtrl(self.notebook_1_pane_5, -1, "0")
        self.text_ctrl_2 = wx.TextCtrl(self.notebook_1_pane_5, -1, "0.1")
        self.text_ctrl_3 = wx.TextCtrl(self.notebook_1_pane_5, -1, "0.001")
        self.text_ctrl_4 = wx.TextCtrl(self.notebook_1_pane_5, -1, "20")
        self.button_30 = wx.Button(self.notebook_1_pane_5, -1, u"読込")
        self.button_21 = wx.Button(self.notebook_1_pane_5, -1, u"編集")
        self.button_29 = wx.Button(self.notebook_1_pane_5, -1, u"適用")
        self.button_28 = wx.Button(self.notebook_1_pane_5, -1, u"Solverを実行")
        self.button_15 = wx.Button(self.notebook_1_pane_5, -1, u"Solverの中断")
        self.button_42 = wx.Button(self.notebook_1_pane_5, -1, u"cpuのモニタ")
        self.label_19 = wx.StaticText(self.notebook_1_pane_5, -1, u"    設定されているsolverを実行する\n")
        self.label_3 = wx.StaticText(self.notebook_1_pane_6, -1, u"並列計算")
        self.button_20 = wx.Button(self.notebook_1_pane_6, -1, u"machines編集")
        self.button_41 = wx.Button(self.notebook_1_pane_6, -1, u"接続状態の確認")
        self.label_40 = wx.StaticText(self.notebook_1_pane_6, -1, u"    並列計算するsubDomainを定義（/etc/hostsで定義されているhostから選択）")
        self.button_35 = wx.Button(self.notebook_1_pane_6, -1, u"decomposeParDict編集")
        self.label_41 = wx.StaticText(self.notebook_1_pane_6, -1, u"    各cpu毎のmesh分割方法を定義。既にmeshを領域分割している場合は設定不要")
        self.button_36 = wx.Button(self.notebook_1_pane_6, -1, u"mesh分割")
        self.label_48_copy = wx.StaticText(self.notebook_1_pane_6, -1, u"    並列計算するcpu毎にmeshを分割します")
        self.button_37 = wx.Button(self.notebook_1_pane_6, -1, u"並列計算開始")
        self.button_39 = wx.Button(self.notebook_1_pane_6, -1, u"計算の中断")
        self.button_43 = wx.Button(self.notebook_1_pane_6, -1, u"cpuのモニタ")
        self.label_49 = wx.StaticText(self.notebook_1_pane_6, -1, u"    並列計算を開始します。（mpirun)")
        self.button_38 = wx.Button(self.notebook_1_pane_6, -1, u"結果の再構築")
        self.label_50 = wx.StaticText(self.notebook_1_pane_6, -1, u"    実行後、cpu毎の計算結果を集め、結果を再構築します。")
        self.label_18_copy = wx.StaticText(self.notebook_1_pane_7, -1, u"結果の確認")
        self.button_16 = wx.Button(self.notebook_1_pane_7, -1, u"paraFoamを実行")
        self.label_20_copy = wx.StaticText(self.notebook_1_pane_7, -1, u"    paraFoamを起動して結果を確認する\n")
        self.button_8 = wx.Button(self.notebook_1_pane_7, -1, u"formToVTKを実行")
        self.label_3_copy = wx.StaticText(self.notebook_1_pane_7, -1, u"    計算結果をVTK変換する\n")
        self.button_33 = wx.Button(self.notebook_1_pane_7, -1, u"吸引力")
        self.label_3_copy_1 = wx.StaticText(self.notebook_1_pane_7, -1, u"    faceZoneを指定して、faceZoneに働く吸引力の計算結果を出力")
        self.button_34 = wx.Button(self.notebook_1_pane_7, -1, u"ローレンツ力")
        self.label_34 = wx.StaticText(self.notebook_1_pane_7, -1, u"    cellZoneを指定して、cellZoneに働くローレンツ力の計算結果を出力\n")
        self.button_18 = wx.Button(self, -1, u"CaseDir変更")
        self.button_17 = wx.Button(self, -1, u"CaseDir開く")
        self.button_10 = wx.Button(self, -1, u"FOAM端末の起動")
        self.button_7 = wx.Button(self, -1, u"閉じる")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.createNewCase, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.changeSolver, self.button_19)
        self.Bind(wx.EVT_BUTTON, self.runUnv2gmshToFoam, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.runIdearsUnvToFoam, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.runTransportProperties, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.makePatch, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.mergeRegions, self.button_31)
        self.Bind(wx.EVT_BUTTON, self.splitRegions, self.button_32)
        self.Bind(wx.EVT_BUTTON, self.clearBoundaryFields, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.editBoundary, self.button_22)
        self.Bind(wx.EVT_BUTTON, self.editBoundaryFields, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.editPropertiesFiles, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.editDictFiles, self.button_23)
        self.Bind(wx.EVT_BUTTON, self.clearInternalFields, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.showFields, self.button_26)
        self.Bind(wx.EVT_BUTTON, self.editSetFieldsDict, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.runSetFields, self.button_14)
        self.Bind(wx.EVT_BUTTON, self.showFields, self.button_27)
        self.Bind(wx.EVT_BUTTON, self.changeSolver, self.button_40)
        self.Bind(wx.EVT_BUTTON, self.editControlDict, self.button_24)
        self.Bind(wx.EVT_BUTTON, self.editFvFile, self.button_25)
        self.Bind(wx.EVT_BUTTON, self.readControlTime, self.button_30)
        self.Bind(wx.EVT_BUTTON, self.editControlTime, self.button_21)
        self.Bind(wx.EVT_BUTTON, self.writeControlTime, self.button_29)
        self.Bind(wx.EVT_BUTTON, self.runSolver, self.button_28)
        self.Bind(wx.EVT_BUTTON, self.stopSolver, self.button_15)
        self.Bind(wx.EVT_BUTTON, self.runCpuMonitor, self.button_42)
        self.Bind(wx.EVT_BUTTON, self.editMachines, self.button_20)
        self.Bind(wx.EVT_BUTTON, self.showNodes, self.button_41)
        self.Bind(wx.EVT_BUTTON, self.editDecomposeParDict, self.button_35)
        self.Bind(wx.EVT_BUTTON, self.runDecomposePar, self.button_36)
        self.Bind(wx.EVT_BUTTON, self.runMPI, self.button_37)
        self.Bind(wx.EVT_BUTTON, self.stopSolver, self.button_39)
        self.Bind(wx.EVT_BUTTON, self.runCpuMonitor, self.button_43)
        self.Bind(wx.EVT_BUTTON, self.runReconsstructPar, self.button_38)
        self.Bind(wx.EVT_BUTTON, self.runParaFoam, self.button_16)
        self.Bind(wx.EVT_BUTTON, self.runFoamToVTK, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.caclMagForce, self.button_33)
        self.Bind(wx.EVT_BUTTON, self.calcEmForce, self.button_34)
        self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGED, self.setLauncherValue, self.notebook_1)
        self.Bind(wx.EVT_BUTTON, self.changeCaseDir, self.button_18)
        self.Bind(wx.EVT_BUTTON, self.openCaseDir, self.button_17)
        self.Bind(wx.EVT_BUTTON, self.runFoamTerm, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.closeOFLauncher, self.button_7)
        # end wxGlade

        self.frame_1_statusbar.SetStatusText("CaseDir: " + dispCaseDir)      
        self.readSetControlTimeInFirstPage()
        titleColor = self.setTitleColor()
        self.label_4.SetForegroundColour(titleColor)



    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("OpenFOAM Launcher")
        _icon = wx.EmptyIcon()
        _icon.CopyFromBitmap(wx.Bitmap("/usr/share/icons/hicolor/48x48/apps/gnome-glines.png", wx.BITMAP_TYPE_ANY))
        self.SetIcon(_icon)
        self.frame_1_statusbar.SetStatusWidths([-1])
        # statusbar fields
        frame_1_statusbar_fields = ["frame_1_statusbar"]
        for i in range(len(frame_1_statusbar_fields)):
            self.frame_1_statusbar.SetStatusText(frame_1_statusbar_fields[i], i)
        self.label_4.SetFont(wx.Font(20, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "VL ゴシック"))
        self.label_1.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.label_44.SetMinSize((60, 17))
        self.label_42.SetBackgroundColour(wx.Colour(255, 245, 236))
        self.label_42.SetFont(wx.Font(12, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "VL ゴシック"))
        self.panel_1.SetBackgroundColour(wx.Colour(255, 245, 236))
        self.label_45.SetMinSize((60, 17))
        self.label_43.SetBackgroundColour(wx.Colour(255, 245, 236))
        self.label_43.SetFont(wx.Font(11, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "VL ゴシック"))
        self.panel_2.SetBackgroundColour(wx.Colour(255, 245, 236))
        self.label_10.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.label_11.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.label_14.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.label_18.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.label_39.SetBackgroundColour(wx.Colour(255, 245, 236))
        self.label_39.SetFont(wx.Font(12, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "VL ゴシック"))
        self.panel_3.SetBackgroundColour(wx.Colour(255, 245, 236))
        self.combo_box_1.SetMinSize((120, 25))
        self.combo_box_1.Enable(False)
        self.combo_box_1.SetSelection(0)
        self.text_ctrl_1.SetMinSize((92, 25))
        self.text_ctrl_1.Enable(False)
        self.text_ctrl_2.SetMinSize((92, 25))
        self.text_ctrl_2.Enable(False)
        self.text_ctrl_3.SetMinSize((92, 25))
        self.text_ctrl_3.Enable(False)
        self.text_ctrl_4.SetMinSize((92, 25))
        self.text_ctrl_4.Enable(False)
        self.button_30.SetMinSize((50, 29))
        self.button_21.SetMinSize((50, 29))
        self.button_29.SetMinSize((50, 29))
        self.label_3.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "VL ゴシック"))
        self.label_18_copy.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.button_18.SetMinSize((98, 29))
        # end wxGlade



    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_19_copy = wx.BoxSizer(wx.VERTICAL)
        sizer_35 = wx.StaticBoxSizer(self.sizer_35_staticbox, wx.VERTICAL)
        sizer_4_copy = wx.StaticBoxSizer(self.sizer_4_copy_staticbox, wx.VERTICAL)
        sizer_21_copy = wx.StaticBoxSizer(self.sizer_21_copy_staticbox, wx.VERTICAL)
        sizer_55 = wx.BoxSizer(wx.VERTICAL)
        sizer_59 = wx.StaticBoxSizer(self.sizer_59_staticbox, wx.VERTICAL)
        sizer_60 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_58 = wx.StaticBoxSizer(self.sizer_58_staticbox, wx.VERTICAL)
        sizer_62 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_19 = wx.BoxSizer(wx.VERTICAL)
        sizer_20 = wx.StaticBoxSizer(self.sizer_20_staticbox, wx.VERTICAL)
        sizer_32 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_34 = wx.StaticBoxSizer(self.sizer_34_staticbox, wx.VERTICAL)
        sizer_37 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_21 = wx.StaticBoxSizer(self.sizer_21_staticbox, wx.VERTICAL)
        sizer_44 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_26 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_38 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_43 = wx.BoxSizer(wx.VERTICAL)
        sizer_33 = wx.BoxSizer(wx.VERTICAL)
        sizer_25 = wx.StaticBoxSizer(self.sizer_25_staticbox, wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.VERTICAL)
        sizer_61 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_22 = wx.StaticBoxSizer(self.sizer_22_staticbox, wx.HORIZONTAL)
        sizer_52 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.VERTICAL)
        sizer_18 = wx.StaticBoxSizer(self.sizer_18_staticbox, wx.VERTICAL)
        sizer_40 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_41 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_17 = wx.StaticBoxSizer(self.sizer_17_staticbox, wx.VERTICAL)
        sizer_39 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_30 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_51 = wx.StaticBoxSizer(self.sizer_51_staticbox, wx.VERTICAL)
        sizer_46 = wx.StaticBoxSizer(self.sizer_46_staticbox, wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_11 = wx.StaticBoxSizer(self.sizer_11_staticbox, wx.VERTICAL)
        sizer_31 = wx.StaticBoxSizer(self.sizer_31_staticbox, wx.VERTICAL)
        sizer_10 = wx.StaticBoxSizer(self.sizer_10_staticbox, wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.VERTICAL)
        sizer_45 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_48 = wx.StaticBoxSizer(self.sizer_48_staticbox, wx.VERTICAL)
        sizer_50 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_49 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_47 = wx.StaticBoxSizer(self.sizer_47_staticbox, wx.VERTICAL)
        sizer_8 = wx.StaticBoxSizer(self.sizer_8_staticbox, wx.VERTICAL)
        sizer_7 = wx.StaticBoxSizer(self.sizer_7_staticbox, wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_24 = wx.StaticBoxSizer(self.sizer_24_staticbox, wx.VERTICAL)
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.VERTICAL)
        sizer_27 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_29 = wx.BoxSizer(wx.VERTICAL)
        sizer_28 = wx.BoxSizer(wx.VERTICAL)
        sizer_53 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_54 = wx.StaticBoxSizer(self.sizer_54_staticbox, wx.HORIZONTAL)
        sizer_57 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_36 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_42 = wx.StaticBoxSizer(self.sizer_42_staticbox, wx.HORIZONTAL)
        sizer_56 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_23 = wx.StaticBoxSizer(self.sizer_23_staticbox, wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add((620, 10), 0, 0, 0)
        sizer_14.Add((200, 20), 0, 0, 0)
        sizer_14.Add(self.label_4, 0, 0, 0)
        sizer_14.Add((50, 20), 0, 0, 0)
        sizer_14.Add(self.label_5, 0, wx.ALIGN_BOTTOM, 0)
        sizer_1.Add(sizer_14, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_2.Add(self.label_1, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_23.Add(self.button_9, 0, 0, 0)
        sizer_23.Add(self.label_6, 0, wx.LEFT, 30)
        sizer_23.Add((20, 10), 0, 0, 0)
        sizer_5.Add(sizer_23, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        sizer_36.Add((10, 20), 0, 0, 0)
        sizer_36.Add(self.label_44, 0, wx.TOP|wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_56.Add(self.label_42, 0, wx.LEFT, 10)
        self.panel_1.SetSizer(sizer_56)
        sizer_42.Add(self.panel_1, 1, wx.EXPAND, 0)
        sizer_36.Add(sizer_42, 1, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        sizer_24.Add(sizer_36, 0, wx.TOP|wx.EXPAND, 0)
        sizer_53.Add((10, 20), 0, 0, 0)
        sizer_53.Add(self.label_45, 0, wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_57.Add(self.label_43, 0, wx.LEFT, 10)
        self.panel_2.SetSizer(sizer_57)
        sizer_54.Add(self.panel_2, 1, wx.EXPAND, 0)
        sizer_53.Add(sizer_54, 1, wx.LEFT|wx.RIGHT|wx.EXPAND, 8)
        sizer_53.Add(self.button_19, 0, wx.TOP|wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_53.Add(self.label_8, 0, 0, 0)
        sizer_24.Add(sizer_53, 0, wx.BOTTOM|wx.EXPAND, 0)
        sizer_24.Add(self.label_38, 0, wx.ALIGN_RIGHT, 0)
        sizer_28.Add((20, 20), 0, 0, 0)
        sizer_28.Add(self.label_9, 0, 0, 0)
        sizer_28.Add(self.label_2, 0, 0, 0)
        sizer_27.Add(sizer_28, 1, wx.EXPAND, 0)
        sizer_29.Add(self.label_46, 0, wx.TOP, 5)
        sizer_29.Add(self.label_12, 0, 0, 0)
        sizer_29.Add(self.label_27, 0, 0, 0)
        sizer_29.Add(self.label_28, 0, 0, 0)
        sizer_29.Add(self.label_47, 0, 0, 0)
        sizer_29.Add(self.label_29, 0, 0, 0)
        sizer_27.Add(sizer_29, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_27, 0, wx.EXPAND, 0)
        sizer_3.Add((20, 10), 0, 0, 0)
        sizer_24.Add(sizer_3, 0, wx.ALL|wx.EXPAND, 2)
        sizer_5.Add(sizer_24, 0, wx.ALL|wx.EXPAND, 8)
        sizer_2.Add(sizer_5, 0, wx.EXPAND, 0)
        self.notebook_1_pane_1.SetSizer(sizer_2)
        sizer_6.Add(self.label_10, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_7.Add(self.button_1, 0, 0, 0)
        sizer_7.Add(self.button_3, 0, 0, 0)
        sizer_7.Add((20, 20), 0, 0, 0)
        sizer_6.Add(sizer_7, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_8.Add(self.button_4, 0, 0, 0)
        sizer_8.Add((20, 20), 0, 0, 0)
        sizer_6.Add(sizer_8, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_47.Add(self.button_11, 0, wx.TOP, 20)
        sizer_47.Add(self.label_35, 0, 0, 0)
        sizer_45.Add(sizer_47, 1, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_49.Add(self.button_31, 0, wx.TOP, 20)
        sizer_48.Add(sizer_49, 0, wx.EXPAND, 0)
        sizer_48.Add(self.label_23, 0, wx.LEFT, 10)
        sizer_50.Add(self.button_32, 0, wx.TOP, 20)
        sizer_48.Add(sizer_50, 0, wx.EXPAND, 0)
        sizer_48.Add(self.label_36, 0, wx.LEFT, 10)
        sizer_45.Add(sizer_48, 1, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_6.Add(sizer_45, 0, wx.EXPAND, 0)
        self.notebook_1_pane_2.SetSizer(sizer_6)
        sizer_9.Add(self.label_11, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_10.Add(self.button_5, 0, 0, 0)
        sizer_10.Add(self.label_13, 0, wx.BOTTOM, 10)
        sizer_9.Add(sizer_10, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_31.Add(self.button_22, 0, 0, 0)
        sizer_31.Add(self.label_30, 0, wx.BOTTOM, 10)
        sizer_9.Add(sizer_31, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_11.Add(self.button_6, 0, 0, 0)
        sizer_11.Add(self.label_31, 0, wx.BOTTOM, 10)
        sizer_9.Add(sizer_11, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        self.notebook_1_pane_3.SetSizer(sizer_9)
        sizer_15.Add(self.label_14, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_46.Add(self.button_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_46.Add(self.label_37, 0, wx.LEFT|wx.BOTTOM, 10)
        sizer_30.Add(sizer_46, 1, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_51.Add(self.button_23, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_51.Add(self.label_26, 0, wx.LEFT, 10)
        sizer_30.Add(sizer_51, 1, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_16.Add(sizer_30, 1, wx.EXPAND, 0)
        sizer_39.Add(self.button_12, 0, 0, 0)
        sizer_39.Add(self.button_26, 0, wx.LEFT, 20)
        sizer_17.Add(sizer_39, 1, wx.EXPAND, 0)
        sizer_17.Add(self.label_15, 0, 0, 0)
        sizer_16.Add(sizer_17, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_41.Add(self.button_13, 0, 0, 0)
        sizer_41.Add(self.label_25, 0, wx.LEFT|wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_18.Add(sizer_41, 0, wx.EXPAND, 0)
        sizer_18.Add((20, 5), 0, 0, 0)
        sizer_40.Add(self.button_14, 0, wx.TOP, 0)
        sizer_40.Add(self.button_27, 0, wx.LEFT, 20)
        sizer_18.Add(sizer_40, 0, wx.EXPAND, 0)
        sizer_18.Add(self.label_17, 0, wx.BOTTOM, 10)
        sizer_16.Add(sizer_18, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_15.Add(sizer_16, 0, wx.EXPAND, 0)
        self.notebook_1_pane_4.SetSizer(sizer_15)
        sizer_19.Add(self.label_18, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_52.Add(self.label_39, 0, wx.LEFT, 10)
        self.panel_3.SetSizer(sizer_52)
        sizer_22.Add(self.panel_3, 1, wx.EXPAND, 0)
        sizer_61.Add(sizer_22, 1, wx.ALL|wx.EXPAND, 4)
        sizer_61.Add(self.button_40, 0, wx.TOP, 15)
        sizer_34.Add(sizer_61, 1, wx.EXPAND, 0)
        sizer_4.Add(self.button_24, 0, wx.LEFT|wx.TOP|wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_4.Add(self.label_20, 0, wx.LEFT|wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_4.Add(self.button_25, 0, wx.LEFT|wx.TOP|wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_4.Add(self.label_24, 0, wx.LEFT|wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_25.Add(sizer_4, 0, wx.RIGHT|wx.EXPAND, 8)
        sizer_37.Add(sizer_25, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 4)
        sizer_26.Add((20, 20), 0, 0, 0)
        sizer_33.Add(self.label_7, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_RIGHT, 4)
        sizer_33.Add(self.label_16, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_RIGHT, 4)
        sizer_33.Add(self.label_21, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_RIGHT, 4)
        sizer_33.Add(self.label_32, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_RIGHT, 4)
        sizer_33.Add(self.label_33, 0, wx.LEFT|wx.TOP|wx.BOTTOM|wx.ALIGN_RIGHT, 4)
        sizer_26.Add(sizer_33, 0, wx.EXPAND, 0)
        sizer_43.Add(self.combo_box_1, 0, 0, 0)
        sizer_43.Add(self.text_ctrl_1, 0, 0, 0)
        sizer_43.Add(self.text_ctrl_2, 0, 0, 0)
        sizer_43.Add(self.text_ctrl_3, 0, 0, 0)
        sizer_43.Add(self.text_ctrl_4, 0, 0, 0)
        sizer_38.Add(sizer_43, 1, wx.EXPAND, 0)
        sizer_26.Add(sizer_38, 1, wx.EXPAND, 0)
        sizer_21.Add(sizer_26, 0, wx.EXPAND, 0)
        sizer_44.Add(self.button_30, 0, wx.LEFT, 90)
        sizer_44.Add(self.button_21, 0, wx.LEFT|wx.BOTTOM, 10)
        sizer_44.Add(self.button_29, 0, wx.LEFT|wx.RIGHT, 10)
        sizer_21.Add(sizer_44, 0, wx.EXPAND, 0)
        sizer_37.Add(sizer_21, 1, wx.LEFT|wx.RIGHT|wx.BOTTOM, 4)
        sizer_34.Add(sizer_37, 0, wx.EXPAND, 0)
        sizer_19.Add(sizer_34, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_32.Add(self.button_28, 0, 0, 0)
        sizer_32.Add((20, 20), 0, 0, 0)
        sizer_32.Add(self.button_15, 0, 0, 0)
        sizer_32.Add((40, 20), 0, 0, 0)
        sizer_32.Add(self.button_42, 0, 0, 0)
        sizer_20.Add(sizer_32, 0, wx.EXPAND, 0)
        sizer_20.Add(self.label_19, 0, 0, 0)
        sizer_19.Add(sizer_20, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        self.notebook_1_pane_5.SetSizer(sizer_19)
        sizer_55.Add(self.label_3, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_62.Add(self.button_20, 0, wx.TOP, 8)
        sizer_62.Add((20, 20), 0, 0, 0)
        sizer_62.Add(self.button_41, 0, wx.TOP, 8)
        sizer_58.Add(sizer_62, 1, wx.EXPAND, 0)
        sizer_58.Add(self.label_40, 0, 0, 0)
        sizer_58.Add(self.button_35, 0, wx.TOP, 4)
        sizer_58.Add(self.label_41, 0, wx.BOTTOM, 10)
        sizer_55.Add(sizer_58, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_59.Add(self.button_36, 0, wx.TOP, 4)
        sizer_59.Add(self.label_48_copy, 0, 0, 0)
        sizer_60.Add(self.button_37, 0, wx.TOP, 4)
        sizer_60.Add((20, 20), 0, 0, 0)
        sizer_60.Add(self.button_39, 0, wx.TOP, 4)
        sizer_60.Add((40, 20), 0, 0, 0)
        sizer_60.Add(self.button_43, 0, 0, 0)
        sizer_59.Add(sizer_60, 1, wx.EXPAND, 0)
        sizer_59.Add(self.label_49, 0, 0, 0)
        sizer_59.Add(self.button_38, 0, wx.TOP, 4)
        sizer_59.Add(self.label_50, 0, wx.BOTTOM, 4)
        sizer_55.Add(sizer_59, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        self.notebook_1_pane_6.SetSizer(sizer_55)
        sizer_19_copy.Add(self.label_18_copy, 0, wx.TOP|wx.BOTTOM|wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_21_copy.Add(self.button_16, 0, wx.TOP, 8)
        sizer_21_copy.Add(self.label_20_copy, 0, 0, 0)
        sizer_19_copy.Add(sizer_21_copy, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_4_copy.Add(self.button_8, 0, wx.TOP, 8)
        sizer_4_copy.Add(self.label_3_copy, 0, 0, 0)
        sizer_19_copy.Add(sizer_4_copy, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        sizer_35.Add(self.button_33, 0, wx.TOP, 8)
        sizer_35.Add(self.label_3_copy_1, 0, 0, 0)
        sizer_35.Add(self.button_34, 0, wx.TOP, 8)
        sizer_35.Add(self.label_34, 0, 0, 0)
        sizer_19_copy.Add(sizer_35, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM|wx.EXPAND, 8)
        self.notebook_1_pane_7.SetSizer(sizer_19_copy)
        self.notebook_1.AddPage(self.notebook_1_pane_1, u"解析の概要")
        self.notebook_1.AddPage(self.notebook_1_pane_2, u"メッシュ")
        self.notebook_1.AddPage(self.notebook_1_pane_3, u"境界条件")
        self.notebook_1.AddPage(self.notebook_1_pane_4, u"データセット")
        self.notebook_1.AddPage(self.notebook_1_pane_5, u"計算開始")
        self.notebook_1.AddPage(self.notebook_1_pane_6, u"並列計算")
        self.notebook_1.AddPage(self.notebook_1_pane_7, u"結果の確認")
        sizer_1.Add(self.notebook_1, 1, wx.ALL|wx.EXPAND, 4)
        sizer_12.Add((20, 10), 0, 0, 0)
        sizer_13.Add(self.button_18, 0, wx.LEFT|wx.BOTTOM|wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_13.Add((30, 20), 0, 0, 0)
        sizer_13.Add(self.button_17, 0, 0, 0)
        sizer_13.Add((50, 20), 0, 0, 0)
        sizer_13.Add(self.button_10, 0, 0, 0)
        sizer_13.Add((120, 20), 0, 0, 0)
        sizer_13.Add(self.button_7, 0, 0, 0)
        sizer_12.Add(sizer_13, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_12, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #---解析の概要-------------------------------
    def createNewCase(self, event): # wxGlade: MyFrame.<event_handler>
        print "新規にCaseを作成します。"
        pyOFLauncher.createNewCase()
        event.Skip()

    def changeSolver(self, event): # wxGlade: MyFrame.<event_handler>
        print "solverを入れ替えます。"
        pyOFLauncher.changeSolver()
        event.Skip()

    #---メッシュ-------------------------------------
    def runUnv2gmshToFoam(self, event): # wxGlade: MyFrame.<event_handler>
        print "mesh変換します。"
        title = u"メッシュ変換"
        message = u"「unv2gmshToFoam」でメッシュ変換します。\n　（volumeを定義した上で変換してください。）"
        ans = self.okCancelDialog(title, message)
        if ans == "OK":
            pyOFLauncher.unv2gmshToFoam()
        event.Skip()

    def runIdearsUnvToFoam(self, event): # wxGlade: MyFrame.<event_handler>
        print "mesh変換します。"
        title = u"メッシュ変換"
        message = u"「ideasUnvToFoam」でメッシュ変換します。\n　（volumeを定義した場合は、unv2gmshToFoamでメッシュ変換してください。）"
        ans = self.okCancelDialog(title, message)
        if ans == "OK":
            pyOFLauncher.ideasUnvToFoam()
        event.Skip()

    def runTransportProperties(self, event): # wxGlade: MyFrame.<event_handler>
        print "モデルのスケールを変更します。"
        pyOFLauncher.scaleMesh()
        event.Skip()

    def reloadControlDict(self, event): # wxGlade: MyFrame.<event_handler>
        print "controlDictを読み込み再セットします。"
        self.readSetControlTimeInFirstPage()
        event.Skip()

    def makePatch(self, event): # wxGlade: MyFrame.<event_handler>
        print "内部パッチを作成します。"
        pyOFLauncher.makePatch()
        event.Skip()

    def mergeRegions(self, event): # wxGlade: MyFrame.<event_handler>
        print "選択したcellZone同士を結合します。"
        pyOFLauncher.mergeRegionsCellZone()
        event.Skip()

    def splitRegions(self, event): # wxGlade: MyFrame.<event_handler>
        print "cellZone毎にメッシュの領域を分割します。"
        if self.okCancelDialog(u"メッシュの領域分割",
                                u"メッシュをcellZone毎に領域分割します。") == "OK":            
            pyOFLauncher.splitRegionsCellZone()
        event.Skip()

    #---境界条件-----------------------------------
    def clearBoundaryFields(self, event): # wxGlade: MyFrame.<event_handler>
        print "BoundaryFieldのクリア"
        pyOFLauncher.clearBoundaryFields()
        event.Skip()

    def editBoundary(self, event): # wxGlade: MyFrame.<event_handler>
        print "boundaryを編集します。"
        pyOFLauncher.editBoundaryFile()
        event.Skip()

    def editBoundaryFields(self, event): # wxGlade: MyFrame.<event_handler>
        print "Fieldsを編集します。"
        pyOFLauncher.editFields()
        event.Skip()

    #---データセット--------------------------------
    def editPropertiesFiles(self, event): # wxGlade: MyFrame.<event_handler>
        print "...Propertiesを編集します。"
        pyOFLauncher.editPropertiesFiles()
        event.Skip()

    def editDictFiles(self, event): # wxGlade: MyFrame.<event_handler>
        print "Dictionaryの編集"
        pyOFLauncher.editDict()
        event.Skip()

    def clearInternalFields(self, event): # wxGlade: MyFrame.<event_handler>
        pyOFLauncher.clearInternalFields()
        event.Skip()

    def showFields(self, event): # wxGlade: MyFrame.<event_handler>
        print "各fieldを編集します。"
        pyOFLauncher.editFields()
        event.Skip()

    def editSetFieldsDict(self, event): # wxGlade: MyFrame.<event_handler>
        print "setFieldsDictを編集します。"
        fileName = "./system/setFieldsDict"
        files = glob.glob(fileName)
        if len(files) == 0: 
            setFoamContents.setFieldsDictDefault()
            msg = "setFieldsDictがなかったので、標準の「setFieldsDict」を作成しました。"
            self.okDialog("setFieldsDictの編集", msg)
        pyOFLauncher.makeFieldsCellzones()
        command = "gedit --new-window " + fileName + " " + "nameList &"
        os.system(command)
        event.Skip()

    def runSetFields(self, event): # wxGlade: MyFrame.<event_handler>
        print "setFieldsを実行します。"
        title = u"setFields"
        message = u"Fieldにデータをセットします。\n　（setFieldsの実行）"
        ans = self.okCancelDialog(title, message)
        if ans == "OK":
            command = ". bashrc-FOAM; setFields"
            os.system(command)
            title = u"setFields"
            message = u"「setFields」でFieldにデータをセットしました。"
            self.okDialog(title, message)
        event.Skip()

    #---計算開始----------------------------
    def editControlDict(self, event): # wxGlade: MyFrame.<event_handler>
        print "controlDictを編集します"
        command = "gedit --new-window system/controlDict &"
        os.system(command)
        nameList = pyOFLauncher.getControlDict(CaseDir)
        event.Skip()

    def editFvFile(self, event): # wxGlade: MyFrame.<event_handler>
        print "fvSchemes, fvSolutionを編集します。"
        pyOFLauncher.editFvFiles()
        event.Skip()

    def runSolver(self, event): # wxGlade: MyFrame.<event_handler>
        pyOFLauncher.selectSolve()
        event.Skip()

    def stopSolver(self, event): # wxGlade: MyFrame.<event_handler>
        print u"solverを中断します。"
        os.system(". bashrc-FOAM; killSolver")
        event.Skip()

    def runCpuMonitor(self, event): # wxGlade: MyFrame.<event_handler>
        print "計算開始：cpuモニタ（ganglia）を起動します。"
        command = "restartGanglia; firefox http://localhost/ganglia &"
        os.system(command)
        event.Skip()

    def readControlTime(self, event): # wxGlade: MyFrame.<event_handler>
        print "controlDictの読込"
        self.readSetControlTimeInBox()
        event.Skip()

    def readSetControlTimeInBox(self):
        items = ["application", "startFrom", "startTime", "endTime", "deltaT", "writeInterval"]
        wdir = os.getcwd()
        itemsValue = getFoamContents.controlDict(wdir+"/system", items)
        self.text_ctrl_1.SetValue(itemsValue[2])    #startTime
        self.text_ctrl_2.SetValue(itemsValue[3])    #endTime
        self.text_ctrl_3.SetValue(itemsValue[4])    #deltaT
        self.text_ctrl_4.SetValue(itemsValue[5])    #writeInterval
        self.label_39.SetLabel(itemsValue[0])       #solver
        if itemsValue[1] == "latestTime":           #startFrom
            self.combo_box_1.SetSelection(1)            #latestTime
        else:
            self.combo_box_1.SetSelection(0)            #startTime

    def editControlTime(self, event): # wxGlade: MyFrame.<event_handler>
        print "controlDictをbox内で編集します。"
        self.combo_box_1.Enable(True)
        self.text_ctrl_1.Enable(True)
        self.text_ctrl_2.Enable(True)
        self.text_ctrl_3.Enable(True)
        self.text_ctrl_4.Enable(True)
        event.Skip()

    def writeControlTime(self, event): # wxGlade: MyFrame.<event_handler>
        print "box内のcontrolTimeを書き込みます。"
        items = []; value = []
        value.append("startFrom"); value.append(self.combo_box_1.GetValue())
        items.append(value); value = []
        value.append("startTime");    value.append(self.text_ctrl_1.GetValue())
        items.append(value); value = []
        value.append("endTime");      value.append(self.text_ctrl_2.GetValue())
        items.append(value); value = []
        value.append("deltaT");       value.append(self.text_ctrl_3.GetValue())
        items.append(value); value = []
        value.append("writeInterval"); value.append(self.text_ctrl_4.GetValue())
        items.append(value)
        wdir = os.getcwd() + "/system"
        setFoamContents.controlDict(wdir, items)
        self.combo_box_1.Enable(False)
        self.text_ctrl_1.Enable(False)
        self.text_ctrl_2.Enable(False)
        self.text_ctrl_3.Enable(False)
        self.text_ctrl_4.Enable(False)
        event.Skip()

    #---並列計算----------------------------
    def editMachines(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：mashinesを編集します。"
        fileName = "./machines"
        files = glob.glob(fileName)
        if len(files) == 0: 
            setFoamContents.setMachinesDefault()
            msg = "machinesがなかったので、標準の「machines」を作成しました。\n 「localhost cpu=4」で作成しています。"
            self.okDialog("machinesの編集", msg)
        command = "gedit --new-window " + fileName + "&"
        os.system(command)
        event.Skip()

    def showNodes(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：接続されているnodeを表示します。"
        pyOFLauncher.showConnectedNodes()
        event.Skip()

    def editDecomposeParDict(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：decomposeParDictを編集します。"
        if len(glob.glob("./constant/cellToRegion")) == 0:
            fileName = "./system/decomposeParDict"
            files = glob.glob(fileName)
            if len(files) == 0: 
                setFoamContents.setDecomposeParDictDefault()
                msg = "decomposeParDictがなかったので、標準の「decomposeParDict」を作成しました。\n 4並列で作成しています。"
                self.okDialog("decomposeParDictの編集", msg)
            command = "gedit --new-window " + fileName + " &"
            os.system(command)
        else:
            message = u"既にmeshが領域分割されています。\n並列系算の為の領域分割の定義は、不要です。cpu毎の領域分割は、meshの領域分割毎で行われます。\n次のmesh分割に進んでください。"
            title = 'edit descomposeParDict'
            self.okDialog(title,message)
        event.Skip()

    def runDecomposePar(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：meshをcpu毎に分割します。"
        pyOFLauncher.delProcessor()
        if len(glob.glob("./constant/cellToRegion")) != 0:
            zones = getFoamContents.cellZoneNames()
            comm = ""
            for zone in zones:
                comm = comm + "decomposePar -region " + zone + "\n"
            command = ". bashrc-FOAM; " + comm
            os.system(command)
        else:
            command = ". bashrc-FOAM; decomposePar"
            os.system(command)
        self.okDialog("メッシュ分割", "cpu毎にメッシュを分割しました。")        
        event.Skip()

    def runMPI(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：並列計算を開始します。"
        pyOFLauncher.runMPI()
        event.Skip()

    def runReconsstructPar(self, event): # wxGlade: MyFrame.<event_handler>
        print "並列計算：cpu毎の計算結果をまとめます。"
        pyOFLauncher.delResultWithoutStartTime()
        if len(glob.glob("./constant/cellToRegion")) != 0:
            zones = getFoamContents.cellZoneNames()
            comm = ""
            for zone in zones:
                comm = comm + "reconstructPar -region " + zone + "\n"
            command = ". bashrc-FOAM; " + comm
            print command
            os.system(command)
        else:
            command = ". bashrc-FOAM; reconstructPar"
            os.system(command)
        event.Skip()

    #---結果----------------------------
    def runParaFoam(self, event): # wxGlade: MyFrame.<event_handler>
        print "paraFoamを実行します。"
        pyOFLauncher.runParaFoam()
        event.Skip()

    def runFoamToVTK(self, event): # wxGlade: MyFrame.<event_handler>
        print "foamToVTKを実行します。"
        command = ". bashrc-FOAM; foamToVTK"
        os.system(command)
        title = u"foamToVTK変換"
        message = u"Foam形式からVTK形式への変換が終了しました。"
        self.okDialog(title, message)
        event.Skip()

    def caclMagForce(self, event): # wxGlade: MyFrame.<event_handler>
        print "指定されたfaceZoneに働く吸引力を計算します。"
        pyOFLauncher.calcMagForce()
        event.Skip()

    def calcEmForce(self, event): # wxGlade: MyFrame.<event_handler>
        print "指定されたcellZoneに働くローレンツ力を計算します。"
        pyOFLauncher.calcEmForce()
        event.Skip()

    #---欄外-----------------------------
    def changeCaseDir(self, event): # wxGlade: MyFrame.<event_handler>
        global CaseDir, ShowFlag

        self.frame_1_statusbar.SetStatusText("CaseDir: *****************")

        print "CaseDirを設定します"
        workdir = os.getcwd()
        dlg = wx.DirDialog(self, message=u"Work Dirを選択してください", 
                style=wx.DD_DEFAULT_STYLE | wx.DD_NEW_DIR_BUTTON)
        if dlg.ShowModal() == wx.ID_OK:
            workdir = dlg.GetPath()
        dlg.Destroy()
        if os.path.isdir(workdir) : 
            os.chdir(workdir)
            dirName = pyOFLauncher.checkCase()
            print "case=", dirName
            if pyOFLauncher.checkCase() == "OK":
                message = u"Work Dir を\n" + workdir + u"\nに設定しました。"
                title = 'Change Directory'
                self.okDialog(title,message)
                name = workdir.split("/")
                if name[-1] == "subCase" or name[-1] == "regCase":
                    titleColor = "blue"
                    self.label_4.SetForegroundColour(titleColor)
                else:
                    titleColor = "black"
                    self.label_4.SetForegroundColour(titleColor)
                print 'Work Dir = ' + workdir
            else:
                message = u"Work Dir を\n" + workdir + u"\nに設定しました。"
                message = message + u"\n\nこのDirは、OpenFOAMのCaseではありません。"
                title = 'Change Directory'
                self.errDialog(title, message)
                titleColor = "red"
                self.label_4.SetForegroundColour(titleColor)
                print 'Work Dir = ' + workdir

        #　Work Dir　を　書き込み
        pyOFLauncher.setCurrentDirectory(workdir)
        wdir = changeLengthCaseDir(workdir)
        self.frame_1_statusbar.SetStatusText("CaseDir: " + wdir)
        self.readSetControlTimeInFirstPage()
        event.Skip()

    def openCaseDir(self, event): # wxGlade: MyFrame.<event_handler>
        print "CaseDirを開きます。"
        workdir = os.getcwd()
        os.system("nautilus --browser " + workdir)
        event.Skip()

    def runFoamTerm(self, event): # wxGlade: MyFrame.<event_handler>
        print "FOAM端末を起動します。"
        comm = "gnome-terminal -t FOAM端末 -x bash --rcfile /home/caeuser/bin/bashrc-FOAM &"
        os.system(comm)
        event.Skip()

    def closeOFLauncher(self, event): # wxGlade: MyFrame.<event_handler>
        print "フレームを消します。"
        frame_1.Destroy()
        event.Skip()

    #---その他----------------------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        if ans == wx.ID_OK:
            dlg.Destroy()
            return "OK"
        else:
            dlg.Destroy()
            return "CANCEL"

    def setLauncherValue(self, event): # wxGlade: MyFrame.<event_handler>
        print "Launcherに値をセットします。"
        self.readSetControlTimeInBox()
        self.readSetControlTimeInFirstPage()
        event.Skip()

    def setTitleColor(self):
        global CaseDir
        if pyOFLauncher.checkCase() == "OK":
            caseName = CaseDir.split("/")[-1]
            if caseName == "subCase" or caseName == "regCase":
                titleColor = "blue"
            else:
                titleColor = "black"
        else:
            titleColor = "red"
        return titleColor


    def readSetControlTimeInFirstPage(self):
        wdir = os.getcwd()
        nameList = pyOFLauncher.getControlDict(wdir)
        caseName = wdir.split("/")[-1]
        solver = nameList[1][0]
        self.label_42.SetLabel(caseName)
        self.label_43.SetLabel(solver)
        self.label_9.SetLabel("     計算: " + nameList[1][5] + " -> " + nameList[1][6])
        self.label_2.SetLabel("     書込: " + nameList[1][7])
        self.label_46.SetLabel("    startFrom: " + nameList[1][5])
        self.label_12.SetLabel("    startTime: " + nameList[1][1])
        self.label_27.SetLabel("      endTime: " + nameList[1][2])
        self.label_28.SetLabel("       deltaT: " + nameList[1][3])
        self.label_47.SetLabel(" writeControl: " + nameList[1][7])
        self.label_29.SetLabel("writeInterval: " + nameList[1][4])
        print caseName, solver, "をセットしました。"

# end of class MyFrame


if __name__ == "__main__":
    CaseDir = pyOFLauncher.readCurrentDirectory()
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


