#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Sun Mar  7 14:25:50 2010
#
#  SolveParaOKDialog.py
#  ----------------
#
#      並列処理の実行
#      計算結果が残っていた場合のSolverの実行方法を選択
#
#   programed by s.fujii
#       10/04/30    新規作成
#

import os
import wx
import glob
import re
import pyOFLauncher
import getFoamContents
import setFoamContents

frame_1 = ""
startFrom = ""
message = ""
timeFolders = []


def Show():
    global frame_1, startFrom, message, timeFolders
    message = getParaJobMessage()
    controlDictItems = getControlDictItems()
    startFrom = controlDictItems[0]
    timeFolders = pyOFLauncher.getTimeFolders(os.getcwd() + "/processor0")
    subMsg = getSubMessage(controlDictItems, timeFolders)
    if len(timeFolders) >= 2:
        message = message + u"計算結果「時間フォルダ」があります。\n「時間フォルダの処理」を選択して実行してください。\n"
        message = message + subMsg + u"\n選択した処理に応じて、controlDictを書き換えます。"
    else:
        message = message + u"計算開始します。以下の設定を確認後、実行してください。\n" + subMsg
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()

def getParaJobMessage():
    Ncpu = str(len(glob.glob("processor*")))
    message = u"並列計算は「" + Ncpu + u"」並列で実行します。\n\n"
    return message

def getControlDictItems():
        items = []
        items.append("startFrom")
        items.append("startTime")
        items.append("endTime")
        items.append("deltaT")
        items.append("writeControl")
        items.append("writeInterval")
        wdir = os.getcwd()
        itemsValue = getFoamContents.controlDict(wdir+"/system", items)
        return itemsValue

def getSubMessage(items, timeFolders):
    msg = "\n     startFrom "
    if items[0] == "startTime":
        m = " " + items[0] + ": "+ items[1]
    elif items[0] == "latestTime":
        m = items[0] + ": " + timeFolders[-1]
    else:
        m = ""
    msg = msg + m + "\n"
    msg = msg + "                  endTime: " + items[2] + "\n"
    msg = msg + "                   deltaT: " + items[3] + "\n"
    msg = msg + "             writeControl: " + items[4] + "\n"
    msg = msg + "            writeInterval: " + items[5] + "\n"
    return msg


# begin wxGlade: extracode
# end wxGlade

#-------修正なし--------------------------


class MyFrame(wx.Frame):
    global frame_1, startFrom, message, timeFolders
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.sizer_4_staticbox = wx.StaticBox(self, -1, u"時間フォルダの処理")
        self.bitmap_1 = wx.StaticBitmap(self, -1, wx.Bitmap("/usr/share/icons/gnome/32x32/status/dialog-warning.png", wx.BITMAP_TYPE_ANY))
        self.label_1_copy = wx.StaticText(self, -1, u"「4」並列で計算します。\n\n計算結果「時間フォルダ」があります。\n「時間フォルダの処理」を選択して実行してください。\n\n\n\n\n\n\n\n")
        self.radio_btn_1 = wx.RadioButton(self, -1, u"削除して実行（startTime)")
        self.radio_btn_2 = wx.RadioButton(self, -1, u"削除せず上書きする（startTime）")
        self.radio_btn_3 = wx.RadioButton(self, -1, u"継続して実行（latestTime）")
        self.label_1 = wx.StaticText(self, -1, u"    継続する場合は、「endTime」の設定を要確認。")
        self.button_1 = wx.Button(self, -1, u"キャンセル")
        self.button_2 = wx.Button(self, -1, "OK")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.cancel, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.run, self.button_2)
        # end wxGlade


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(u"並列処理の実行方法")
        self.button_2.SetFocus()
        # end wxGlade

        if startFrom == "latestTime":
            self.radio_btn_3.SetValue(True)
        if len(timeFolders) == 1:
            self.radio_btn_2.SetValue(True)
            self.radio_btn_1.Enable(False)
            self.radio_btn_2.Enable(False)
            self.radio_btn_3.Enable(False)
            self.sizer_4_staticbox.Enable(False)
            self.label_1.Enable(False)
        self.label_1_copy.SetLabel(message)


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.bitmap_1, 0, 0, 0)
        sizer_2.Add((10, 20), 0, 0, 0)
        sizer_2.Add(self.label_1_copy, 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_3.Add((10, 20), 0, 0, 0)
        sizer_4.Add(self.radio_btn_1, 0, 0, 0)
        sizer_4.Add(self.radio_btn_2, 0, 0, 0)
        sizer_4.Add(self.radio_btn_3, 0, 0, 0)
        sizer_3.Add(sizer_4, 1, 0, 0)
        sizer_3.Add((10, 20), 0, 0, 0)
        sizer_1.Add(sizer_3, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_1.Add(self.label_1, 0, 0, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_5.Add((100, 20), 0, 0, 0)
        sizer_5.Add(self.button_1, 0, 0, 0)
        sizer_5.Add((10, 20), 0, 0, 0)
        sizer_5.Add(self.button_2, 0, 0, 0)
        sizer_5.Add((20, 20), 0, 0, 0)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def run(self, event): # wxGlade: MyFrame.<event_handler>
        if self.radio_btn_1.GetValue() == True:
            print "計算結果を削除して、solverを実行します"
            self.Destroy()
            pyOFLauncher.delResultWithoutStartTime()
            pyOFLauncher.delParaResult()
            setStartTime("startTime")
            solveJob()
        elif self.radio_btn_2.GetValue() == True:
            print "既にある計算結果に上書きして、solverを実行します"
            frame_1.Destroy()
            setStartTime("startTime")
            solveJob()
        else:
            print "既にある計算結果に継続してsolverを実行します"
            frame_1.Destroy()
            setStartTime("latestTime")
            solveJob()
        event.Skip()

    def cancel(self, event): # wxGlade: MyFrame.<event_handler>
        self.Destroy()
        event.Skip()

# end of class MyFrame


#
# solveJob
#   solverを実行
def solveJob():
    print "solverを実行します。"
    f=open("solve.log","w")         #solve.logのクリア
    f.close()
    command = "killPlotWatcher; killTail"
    os.system(command)
    Ncpu = str(len(glob.glob("processor*")))
    command = ". bashrc-FOAM; pyFoamPlotWatcher.py solve.log & solvePara " + Ncpu + " 1> solve.log 2> solve.error & tail -f solve.error &"
    os.system(command)
#    command = "firefox http://localhost/ganglia &"
#    os.system(command)


#
#  setStartTime
#    startFromを書き換える
#
def setStartTime(repTime):
    val = []
    val.append("startFrom")
    val.append(repTime)
    items = []
    items.append(val)
    wdir = os.getcwd() + "/system"
    setFoamContents.controlDict(wdir, items)


if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
