#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Sun Apr 10 13:38:31 2011
#
#       meshOperationDialog.py
#
#       メッシュ操作に関する処理
#
#       programed by s.fujii
#           11/04/10    新規作成
#

import wx
import os
import glob
import string
import pyOFLauncher
import pyTreeFoam
import getFoamContents
import splitMeshCellZones
import separateCellZoneGroupDialog
import selectConjugateCouplingFieldsDialog
import mergeZonesDialog
import mergeRegionsCellZone
import changeZoneNameDialog
import setCouplingConjugateDialog


# begin wxGlade: extracode
# end wxGlade

def Show():
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()

class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.sizer_10_staticbox = wx.StaticBox(self, -1, u"名称変更")
        self.sizer_6_staticbox = wx.StaticBox(self, -1, u"内部パッチの作成")
        self.sizer_7_staticbox = wx.StaticBox(self, -1, u"領域分割")
        self.sizer_2_staticbox = wx.StaticBox(self, -1, u"メッシュ変換")
        self.label_8 = wx.StaticText(self, -1, u"メッシュ操作に関する処理の実行")
        self.button_1 = wx.Button(self, -1, u"  unv2gmshToFoam...  \n(face,volumeをｸﾞﾙｰﾌﾟ化)")
        self.button_2 = wx.Button(self, -1, u"  ideasUnvToFoam...   \n  (faceのみｸﾞﾙｰﾌﾟ化)   ")
        self.label_2 = wx.StaticText(self, -1, u"unv形式からfoam形式に変換")
        self.button_3 = wx.Button(self, -1, u"スケール変更...")
        self.label_3 = wx.StaticText(self, -1, u"メッシュのスケールを変更")
        self.button_5 = wx.Button(self, -1, u" polyMesh開く ")
        self.button_10 = wx.Button(self, -1, u"faceZone名変更")
        self.button_11 = wx.Button(self, -1, u"cellZone名変更")
        self.button_12 = wx.Button(self, -1, u"faceZone結合...")
        self.label_5 = wx.StaticText(self, -1, u"複数のfaceZoneを結合")
        self.button_4 = wx.Button(self, -1, u"内部patch作成...")
        self.label_4 = wx.StaticText(self, -1, u"internal patchの作成")
        self.button_6 = wx.Button(self, -1, u" cellZone結合... ")
        self.label_6 = wx.StaticText(self, -1, u"複数のcellZoneを結合")
        self.button_7 = wx.Button(self, -1, u"領域分割(Region)...   ")
        self.button_13 = wx.Button(self, -1, u"領域分割(Conjugate)...")
        self.button_9 = wx.Button(self, -1, u"coupling再設定...")
        self.label_7 = wx.StaticText(self, -1, u"cellZone毎に領域分割")
        self.button_8 = wx.Button(self, -1, u"閉じる")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onUnv2gmshToFoam, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onIdeasUnvToFoam, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onScaleChange, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onOpenPolyMesh, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onChangeFaceZoneName, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onChangeCellZoneName, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onMargeFaceZone, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onMakeInternalPatch, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onMargeCellZones, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onMeshSplitCellZones, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onMeshSplitConjugate, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.recoupleConjugate, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_8)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(u"メッシュ操作")
        self.button_7.SetToolTipString(u"chtMutiRegion用に分割")
        self.button_13.SetToolTipString(u"conjugate用に分割")
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.StaticBoxSizer(self.sizer_7_staticbox, wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.StaticBoxSizer(self.sizer_6_staticbox, wx.VERTICAL)
        sizer_10 = wx.StaticBoxSizer(self.sizer_10_staticbox, wx.HORIZONTAL)
        sizer_12 = wx.BoxSizer(wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.label_8, 0, wx.TOP|wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_3.Add(self.button_1, 0, wx.LEFT|wx.RIGHT|wx.TOP, 3)
        sizer_3.Add(self.button_2, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM, 3)
        sizer_3.Add(self.label_2, 0, wx.LEFT|wx.BOTTOM, 5)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_4.Add(self.button_3, 0, wx.TOP, 10)
        sizer_4.Add(self.label_3, 0, wx.LEFT|wx.BOTTOM, 5)
        sizer_2.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 0, wx.ALL|wx.EXPAND, 5)
        sizer_13.Add(self.button_5, 0, wx.ALL, 3)
        sizer_10.Add(sizer_13, 1, wx.EXPAND, 0)
        sizer_11.Add(self.button_10, 0, wx.ALL, 3)
        sizer_10.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_12.Add(self.button_11, 0, wx.ALL, 3)
        sizer_10.Add(sizer_12, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_10, 0, wx.ALL|wx.EXPAND, 5)
        sizer_6.Add(self.button_12, 0, wx.ALL, 3)
        sizer_6.Add(self.label_5, 0, wx.LEFT|wx.BOTTOM, 3)
        sizer_6.Add(self.button_4, 0, wx.ALL, 3)
        sizer_6.Add(self.label_4, 0, wx.LEFT|wx.BOTTOM, 5)
        sizer_5.Add(sizer_6, 1, wx.ALL|wx.EXPAND, 5)
        sizer_7.Add(self.button_6, 0, wx.ALL, 3)
        sizer_7.Add(self.label_6, 0, wx.LEFT|wx.BOTTOM, 5)
        sizer_7.Add(self.button_7, 0, wx.ALL, 3)
        sizer_7.Add(self.button_13, 0, wx.LEFT, 3)
        sizer_14.Add(self.button_9, 0, wx.LEFT, 30)
        sizer_7.Add(sizer_14, 1, wx.EXPAND, 0)
        sizer_7.Add(self.label_7, 0, wx.LEFT|wx.BOTTOM, 5)
        sizer_5.Add(sizer_7, 1, wx.ALL|wx.EXPAND, 5)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_9.Add(self.button_8, 0, wx.ALL|wx.ALIGN_RIGHT, 5)
        sizer_8.Add(sizer_9, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_8, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #unv2gmshToFoam
    def onUnv2gmshToFoam(self, event): # wxGlade: MyFrame.<event_handler>
        print "mesh変換します。"
        title = u"メッシュ変換"
        message = u"「unv2gmshToFoam」でメッシュ変換します。\n　（volumeを定義した上で変換してください。）"
        ans = self.okCancelDialog(title, message)
        if ans == "OK":
            pyOFLauncher.unv2gmshToFoam()
        event.Skip()

    #ideasUnvToFoam
    def onIdeasUnvToFoam(self, event): # wxGlade: MyFrame.<event_handler>
        print "mesh変換します。"
        title = u"メッシュ変換"
        message = u"「ideasUnvToFoam」でメッシュ変換します。\n　（volumeを定義した場合は、unv2gmshToFoamでメッシュ変換してください。）"
        ans = self.okCancelDialog(title, message)
        if ans == "OK":
            pyOFLauncher.ideasUnvToFoam()
        event.Skip()

    #scaleChange
    def onScaleChange(self, event): # wxGlade: MyFrame.<event_handler>
        print "モデルのスケールを変更します。"
        pyOFLauncher.scaleMesh()
        event.Skip()

    #makeInternalPatch
    def onMakeInternalPatch(self, event): # wxGlade: MyFrame.<event_handler>
        print "内部パッチを作成します。"
        pyOFLauncher.makePatch()
        event.Skip()

    #changeCellZoneName
    def onChangeCellZoneName(self, event): # wxGlade: MyFrame.<event_handler>
        print "cellZone名を変更します"
        self.changeCellZoneName()
        event.Skip()

    #mergeCellZones
    def onMargeCellZones(self, event): # wxGlade: MyFrame.<event_handler>
        print "選択したcellZone同士を結合します。"
        self.mergeRegionsCellZone()
        event.Skip()

    #meshSplitCellZones
    def onMeshSplitCellZones(self, event): # wxGlade: MyFrame.<event_handler>
        print "cellZone毎にメッシュの領域を分割します。"
        if self.okCancelDialog(u"メッシュの領域分割",
                                u"メッシュをcellZone毎に領域分割します。") == "OK":            
            self.meshSplitRegion()
        event.Skip()

    #close
    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        self.Close(True)

    #changeFaceZoneName
    def onChangeFaceZoneName(self, event): # wxGlade: MyFrame.<event_handler>
        print "faceZone名を変更します"
        self.changeFaceZoneName()
        event.Skip()

    #mergeFaceZone
    def onMargeFaceZone(self, event): # wxGlade: MyFrame.<event_handler>
        print "選択したfaceZone同士を結合します。"
        self.mergeRegionsFaceZone()
        event.Skip()

    #meshSplitConjugate
    def onMeshSplitConjugate(self, event): # wxGlade: MyFrame.<event_handler>
        title = "メッシュ分割（conjugate用）"
        mess = "メッシュをconjugate用に分割します。"
        result = self.okCancelDialog(title, mess)
        if result == "OK":
            self.meshSplitConjugate()
        event.Skip()

    #openPolyMesh
    def onOpenPolyMesh(self, event): # wxGlade: MyFrame.<event_handler>
        comm = "nautilus --browser " + os.getcwd() + "/constant/polyMesh"
        os.system(comm)
        event.Skip()

    #recoupleConjugate
    def recoupleConjugate(self, event): # wxGlade: MyFrame.<event_handler>
        print "couplingを再設定します"
        self.recoupleConju()
        event.Skip()

# end of class MyFrame

    #
    #  recoupleConju
    #    couplingの再設定
    def recoupleConju(self):
        regions = self.getRegionList()
        setCouplingConjugateDialog.regionList = regions
        dialog = setCouplingConjugateDialog.MyDialog(None)
        result = dialog.ShowModal()

    #  getRegionList
    def getRegionList(self):
        caseDir = os.getcwd()
        mess = ""
        regions = []
        region0 = caseDir + "/constant/polyMesh"
        if len(glob.glob(region0)) != 0:
            regions.append(["region0", region0])
            wdir = caseDir + "/constant"
            [folders, files] = pyTreeFoam.getFoldersFiles(wdir)
            for folder in folders:
                if folder != "polyMesh":
                    region1 = wdir + "/" + folder + "/polyMesh"
                    if len(glob.glob(region1)) != 0:
                        regions.append([folder, region1])
                    else:
                        mess = region1 + "は、存在しません。"
            if len(regions) <= 1:
                mess = "couplingする相手のregionが存在しません。" 
        else:
            mess = "OpenFOAMのcaseDirではありません。"
        if mess != "":
            title = u"エラー"
            self.errDialog(title, mess)
        if len(regions)<=1:
            regions=[]
        return regions

    #
    #  changeCellZoneName
    #    cellZone名の変更
    def changeCellZoneName(self):
        wdir = os.getcwd() + "/constant/polyMesh"
        cellZones = getFoamContents.cellZones(wdir)
        zoneNames = []
        newNames = []
        i=0
        while i < len(cellZones):
            zoneNames.append(cellZones[i][0])
            newNames.append(cellZones[i][0])
            i=i+1
        zoneNames.sort()
        changeZoneNameDialog.title = u"cellZone名の変更"
        changeZoneNameDialog.zoneNames = newNames
        changeZoneNameDialog.message = u"cellZoneを選択して、\n 新しい名前に変更します。"
        dialog = changeZoneNameDialog.MyDialog(None)
        result = dialog.ShowModal()
        if changeZoneNameDialog.status == "OK":
            newNames = changeZoneNameDialog.zoneNames
            dialog.Destroy()
            f=open(wdir + "/cellZones"); contents=f.read(); f.close()
            j=0
            while j<len(zoneNames):
                oldName = zoneNames[j]
                newName = newNames[j]
                if oldName != newName:
                    n = string.find(contents, oldName)
                    if n>=0:
                        i=n
                        contents = contents[:i] + newName + contents[i+len(oldName):]
                        oldZone = wdir + "/sets/" + oldName
                        newZone = wdir + "/sets/" + newName
                        comm = "mv -f " + oldZone + " " + newZone
                        os.system(comm)
                j+=1
            f=open(wdir + "/cellZones", "w"); f.write(contents); f.close()
            title = u"cellZone名の変更"
            mess = u"cellZone名をに変更しました。"
            self.okDialog(title, mess)
        else:
            dialog.Destroy()

    #
    #  changeFaceZoneName
    #    faceZone名の変更
    def changeFaceZoneName(self):
        wdir = os.getcwd() + "/constant/polyMesh"
        faceZones = getFoamContents.faceZones(wdir)
        zoneNames = []
        newNames = []
        i=0
        while i < len(faceZones):
            zoneNames.append(faceZones[i][0])
            newNames.append(faceZones[i][0])
            i=i+1
        zoneNames.sort()
        changeZoneNameDialog.title = u"faceZone名の変更"
        changeZoneNameDialog.zoneNames = newNames
        changeZoneNameDialog.message = u"faceZoneを選択して、\n 新しい名前に変更します。"
        dialog = changeZoneNameDialog.MyDialog(None)
        result = dialog.ShowModal()
        if changeZoneNameDialog.status == "OK":
            newNames = changeZoneNameDialog.zoneNames
            dialog.Destroy()
            f=open(wdir + "/faceZones"); contents=f.read(); f.close()
            j=0
            while j<len(zoneNames):
                oldName = zoneNames[j]
                newName = newNames[j]
                if oldName != newName:
                    n = string.find(contents, oldName)
                    if n>=0:
                        i=n
                        contents = contents[:i] + newName + contents[i+len(oldName):]
                        oldZone = wdir + "/sets/" + oldName
                        newZone = wdir + "/sets/" + newName
                        comm = "mv -f " + oldZone + " " + newZone
                        os.system(comm)
                j+=1
            f=open(wdir + "/faceZones", "w"); f.write(contents); f.close()
            title = u"faceZone名の変更"
            mess = u"faceZone名をに変更しました。"
            self.okDialog(title, mess)
        else:
            dialog.Destroy()

    #
    #  mergeRegionsFaceZone
    #    faceZoneの結合
    def mergeRegionsFaceZone(self):
        wdir = os.getcwd() + "/constant/polyMesh"
        faceZones = getFoamContents.faceZones(wdir)
        zoneNames =[]
        i=0
        while i < len(faceZones):
            zoneNames.append(faceZones[i][0])
            i=i+1
        zoneNames.sort()
        mergeZonesDialog.title = "faceZoneの結合"
        mergeZonesDialog.message = u"結合するfaceZoneを選択してください\n選択したZoneが結合され、1ヶのfaceZoneが出来上がります。"
        mergeZonesDialog.cellZoneNames = zoneNames
        dialog = mergeZonesDialog.MyDialog(None)
        result = dialog.ShowModal()
        if mergeZonesDialog.status == "OK":
            print "faceZoneを結合します"
            mergeName = mergeZonesDialog.mergeName
            mergeFaces = mergeZonesDialog.mergeCells
            dialog.Destroy()
            #command作成
            comm = "mergeCellZones.py " + mergeName + " "
            for name in mergeFaces:
                comm = comm + name + " "
            commArg = comm.split()
            #merge実行
            error = mergeRegionsCellZone.RunFace(commArg)
            if error[0] != "OK":
                title = "エラー"
                message = error[1]
                self.errDialog(title, message)
            else:
                title = u"faceZoneの結合"
                mess = u"「" + string.join(mergeFaces, u",") + u"」を「" + mergeName + u"」に結合しました。"
                self.okDialog(title, mess)
        else:
            dialog.Destroy()

    #
    #  mergeRegionsCellZone
    #    cellZoneの結合
    def mergeRegionsCellZone(self):
        wdir = os.getcwd() + "/constant/polyMesh"
        cellZones = getFoamContents.cellZones(wdir)
        zoneNames =[]
        i=0
        while i < len(cellZones):
            zoneNames.append(cellZones[i][0])
            i=i+1
        zoneNames.sort()
        mergeZonesDialog.title = "cellZoneの結合"
        mergeZonesDialog.message = u"結合するcellZoneを選択してください\n選択したZoneが結合され、1ヶのcellZoneが出来上がります。"
        mergeZonesDialog.cellZoneNames = zoneNames
        dialog = mergeZonesDialog.MyDialog(None)
        result = dialog.ShowModal()
        if mergeZonesDialog.status == "OK":
            print "cellZoneを結合します"
            mergeName = mergeZonesDialog.mergeName
            mergeCells = mergeZonesDialog.mergeCells
            #command作成
            comm = "mergeCellZones.py " + mergeName + " "
            for name in mergeCells:
                comm = comm + name + " "
            commArg = comm.split()
            #merge実行
            error = mergeRegionsCellZone.Run(commArg)
            if error[0] == "NG":
                title = "エラー"
                message = error[1]
                self.okDialog(title, message)
        dialog.Destroy()


    #
    #  meshSplitRegion
    #    chtMultiRegion用にメッシュ分割
    def meshSplitRegion(self):
        error = splitMeshCellZones.Run()
        if error[0] == "NG":
            self.okCancelDialog("エラー", error[1])
        else:
            msg = "領域（region）に分割しました。"
            saveDir = os.getcwd()
            regDir = saveDir + "/regCase"
            os.chdir(regDir)
            wdir = regDir + "/constant/polyMesh"
            cellZones = getFoamContents.cellZones(wdir)
            zoneNames =[]
            i=0
            while i < len(cellZones):
                zoneNames.append(cellZones[i][0])
                i=i+1
            zoneNames.sort()
            separateCellZoneGroupDialog.cellZoneNames = zoneNames
            dialog = separateCellZoneGroupDialog.MyDialog(None)
            result = dialog.ShowModal()
            if separateCellZoneGroupDialog.status == "OK":
                fluidCellZones = separateCellZoneGroupDialog.liquidCellZones
                solidCellZones = separateCellZoneGroupDialog.solidCellZones
                dialog.Destroy()
                msg = "メッシュをcellZone毎に領域分割し、新しい分割Case「regCase」を作成しました。"
                self.okDialog("メッシュの領域分割", msg)
            else:
                dialog.Destroy()
            os.chdir(saveDir)
            


    #
    #  meshSplitCojugate
    #    conjugate用にメッシュ分割
    def meshSplitConjugate(self):
        #regCaseフォルダ有無チェック
        error = checkRegCase()
        if error[0] != "NG":
            #領域分割
            error = splitMeshCellZones.RunConjugate()
        if error[0] != "NG":
            #領域分割後のfluid,solidグループ分け
            saveDir = os.getcwd()
            regDir = saveDir + "/regCase"
            os.chdir(regDir)
            wdir = regDir + "/constant/polyMesh"
            cellZones = getFoamContents.cellZones(wdir)
            os.chdir(saveDir)
            zoneNames =[]
            i=0
            while i < len(cellZones):
                zoneNames.append(cellZones[i][0])
                i=i+1
            zoneNames.sort()
            separateCellZoneGroupDialog.cellZoneNames = zoneNames
            dialog = separateCellZoneGroupDialog.MyDialog(None)
            result = dialog.ShowModal()
            if separateCellZoneGroupDialog.status == "OK":
                fluidCellZones = separateCellZoneGroupDialog.liquidCellZones
                solidCellZones = separateCellZoneGroupDialog.solidCellZones
                dialog.Destroy()
                if len(fluidCellZones) != 1:
                    mess = "流体側のcellZoneが選択されていないか、2ヶ以上選択しています。\n  流体側のcellZoneを1ヶのみ選択してください。"
                    error = ["NG", mess]
                else:
                    #boundaryFileをconjugate用に修正
                    time = pyTreeFoam.getTimeFolders(regDir)
                    splitMeshCellZones.remakeBoundaryFileConjugate(regDir,
                        time[0], fluidCellZones[0])
                    #各fieldのboundaryをregionCouplingに変更
                    wdir = regDir + "/" + time[0] + "/" + fluidCellZones[0]
                    [status, fields] = self.getCouplingFields(wdir)
                    if status == "OK":
                        splitMeshCellZones.remakeBoundaryRegionCoupling(
                            regDir, time[0], fields)
                    #folder整形、リンクの作成
                    pyTreeFoam.remakeFolderConjugate(fluidCellZones,
                        solidCellZones)
                    title = "メッシュの領域分割"
                    mess = "メッシュをconjugate用に分割しました。\n  引き続き継続する場合は、「regCase」に移動してください。"
                    self.okDialog(title, mess)
            else:
                dialog.Destroy()
        # error表示
        if error[0] == "NG":
            title = "エラー"
            mess = error[1]
            self.errDialog(title, mess)

    def getCouplingFields(self, wdir):
        [folders, files] = pyOFLauncher.getFoldersFiles(wdir)
        selectConjugateCouplingFieldsDialog.cellZoneNames = files
        dialog = selectConjugateCouplingFieldsDialog.MyDialog(None)
        result = dialog.ShowModal()
        status = selectConjugateCouplingFieldsDialog.status
        dialog.Destroy()
        fields = []
        if status == "OK":
            fields = selectConjugateCouplingFieldsDialog.liquidCellZones
        return [status, fields]


    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        if ans == wx.ID_OK:
            dlg.Destroy()
            return "OK"
        else:
            dlg.Destroy()
            return "CANCEL"

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()



def checkRegCase():
    wdir = os.getcwd()
    if len(glob.glob(wdir + "/regCase")) == 0:
        error = ["OK", ""]
    else:
        mess = "既に「regCase」が存在します。\n  「regCase」フォルダを削除して再実行してください。"
        error = ["NG", mess]
    return error


def getSplitedRegions():
    wdir = os.getcwd() + "/regCase"
    timeFolders = pyOFLauncher.getTimeFolders(wdir)
    timeFolder = timeFolders[0]
    regions = glob.glob(wdir + "/" + timeFolder + "/*")
    ans = []
    for name in regions:
        region = name.split("/")[-1]
        ans.append(region)
    ans.sort()
    return ans


if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
