#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   treefoam.py
#
#       OpenFOAM用のランチャ
#
#       programed by s.fujii
#       11/04/15    新規作成（ver 1.0）
#          05/08    editBoundary(grid)を追加（ver 1.1）
#          08/17    項目のダブルクリックでフォルダopen、plotWatcher追加（ver1.2）
#       12/01/01    ﾊﾞｸﾞ修正
#                   reloadで数字ﾌｫﾙﾀﾞが存在しない場合、ｴﾗｰが発生していた
#                   gridEditor:boundaryFieldにｺﾒﾝﾄ文がある時、正常に書き込めなかった
#                   フォルダの追加削除を可能にした
#       12/01/03    gridEditorでpatchの削除を可能にした
#          01/06    ﾊﾞｸﾞ修正（ﾌｫﾙﾀﾞ名変更時、修正しない時にｴﾗｰが発生）
#          01/08    gridEditorでのpatch名の変更を可能にした
#          01/15    ﾊﾞｸﾞ修正（最初のpatch削除できなかった）。helpを表示
#          01/17    ﾊﾞｸﾞ修正（patch削除時ｺﾞﾐが残る）、ﾓﾃﾞﾙ倍率の保存方法修正
#          01/21    gridEditorｺﾏﾝﾄﾞ追加。これに伴いﾗﾝﾁｬを修正（ver1.21）
#          01/22    caseOpen, cntDictOpenボタン追加
#
#
#
#-----------code生成後の修正項目----------------
#  ・以下の行をコメントアウトする。
#       self.tree_ctrl_1 = wx.TreeCtrl(...
#


# generated by wxGlade 0.6.3 on Sun Feb 20 15:26:34 2011

import wx
import wx.gizmos
import os
import os.path
import glob
import codecs
import shutil

import pyOFLauncher
import pyTreeFoam
import meshOperationDialog
import setDataInFieldsDialog
import getFoamContents
import selectFieldsDialog
import selectFieldsForEditDialog


version = "1.21-120129"
treeFoamPath = ""
rootDirFix = ""
selCaseDirFix = ""
solveCaseFix = ""
paraFoamFix = ""
salomeMecaFix = ""
envOpenFOAMFix = ""
cadFix = ""
gridNo = []                 #gridのNo、Dirを一時保存
nTreeFoam = ""              #TreeFoamの起動数

rootDir = ""
selCaseDir = ""
treeData = []
selCase = []
configFile = "configTreeFoam"
editName = ""
childrenList = []
timeFolders = ["0","1"]

changeRootID = wx.NewId()
reloadID = wx.NewId()
exitID = wx.NewId()
usageID = wx.NewId()
versionID = wx.NewId()
newCaseID = wx.NewId()
setCurrCaseID = wx.NewId()
editFieldID = wx.NewId()
editPropertiesID = wx.NewId()
editDictID = wx.NewId()
editMeshID = wx.NewId()
renameCaseID = wx.NewId()
runSolverID = wx.NewId()
plotWatcherID = wx.NewId()
paralleleSolverID = wx.NewId()
runFoamTermID = wx.NewId()
runParaFoamID = wx.NewId()
runFoamViewerID = wx.NewId()
runSalomeID = wx.NewId()
runCADID = wx.NewId()
dataSetClearID = wx.NewId()
FolderOpenID = wx.NewId()


# begin wxGlade: extracode
# end wxGlade

class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        global rootDir, selCaseDir, envOpenFOAMFix
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.panel_2 = wx.Panel(self, -1)
        self.panel_1 = wx.Panel(self, -1)
        
        # Menu Bar
        self.frame_1_menubar = wx.MenuBar()
        self.menuFile = wx.Menu()
        self.menuChangeRoot = wx.MenuItem(self.menuFile, changeRootID, u"rootの変更", u"rootDirectoryの変更", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuChangeRoot)
        self.menuReload = wx.MenuItem(self.menuFile, reloadID, u"再読み込み", u"treeDataを再読み込みします", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuReload)
        self.menuNewCase = wx.MenuItem(self.menuFile, newCaseID, u"新規case作成", u"tutorialからコピーして新しいcaseを作成します", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuNewCase)
        self.menuSetCurrCase = wx.MenuItem(self.menuFile, setCurrCaseID, u"解析Caseとして設定", u"選択しているcaseを解析Caseとして設定します", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuSetCurrCase)
        self.menuExit = wx.MenuItem(self.menuFile, exitID, u"閉じる", "", wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuExit)
        self.frame_1_menubar.Append(self.menuFile, u"ファイル")
        self.menuEdit = wx.Menu()
        self.menuFolderOpen = wx.MenuItem(self.menuEdit, FolderOpenID, u"開く", u"解析Caseを開く", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuFolderOpen)
        self.menuEditField = wx.MenuItem(self.menuEdit, editFieldID, u"Field編集", u"解析CaseのFieldを編集します", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuEditField)
        self.menuEditProperties = wx.MenuItem(self.menuEdit, editPropertiesID, u"Properties編集", u"解析Caseのpropertiesを編集します", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuEditProperties)
        self.menuEditDict = wx.MenuItem(self.menuEdit, editDictID, u"Dictionary編集", u"解析CaseのDictを編集します", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuEditDict)
        self.menuEditMesh = wx.MenuItem(self.menuEdit, editMeshID, u"Mesh編集", u"解析Caseのmeshを編集（変換、scale変更等）します", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuEditMesh)
        self.menuDataSetClear = wx.MenuItem(self.menuEdit, dataSetClearID, u"FieldDataSet又はclear", u"Fieldにデータセット、又はクリア", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuDataSetClear)
        self.menuRenameCase = wx.MenuItem(self.menuEdit, renameCaseID, u"case名変更", u"解析Caseの名称を変更します", wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuRenameCase)
        self.frame_1_menubar.Append(self.menuEdit, u"編集")
        self.menuSolve = wx.Menu()
        self.menuRunSolver = wx.MenuItem(self.menuSolve, runSolverID, u"計算開始", u"activeCaseの計算を開始します", wx.ITEM_NORMAL)
        self.menuSolve.AppendItem(self.menuRunSolver)
        self.menuPlotWatcher = wx.MenuItem(self.menuSolve, plotWatcherID, u"plotWatcher起動", u"plotWatcherを起動します。", wx.ITEM_NORMAL)
        self.menuSolve.AppendItem(self.menuPlotWatcher)
        self.menuParalleleSolver = wx.MenuItem(self.menuSolve, paralleleSolverID, u"並列計算", u"並列計算に関する設定を行います", wx.ITEM_NORMAL)
        self.menuSolve.AppendItem(self.menuParalleleSolver)
        self.frame_1_menubar.Append(self.menuSolve, u"計算")
        self.menuTool = wx.Menu()
        self.menuRunCAD = wx.MenuItem(self.menuTool, runCADID, u"CADの起動", u"CADを起動します", wx.ITEM_NORMAL)
        self.menuTool.AppendItem(self.menuRunCAD)
        self.menuRunFoamTerm = wx.MenuItem(self.menuTool, runFoamTermID, u"FOAM端末の起動", u"FOAM端末を起動します", wx.ITEM_NORMAL)
        self.menuTool.AppendItem(self.menuRunFoamTerm)
        self.menuRunParaFoam = wx.MenuItem(self.menuTool, runParaFoamID, u"paraFoamの起動", u"paraFoamを起動します", wx.ITEM_NORMAL)
        self.menuTool.AppendItem(self.menuRunParaFoam)
        self.menuRunFoamViewer = wx.MenuItem(self.menuTool, runFoamViewerID, u"viewerの起動", u"viewerを起動します", wx.ITEM_NORMAL)
        self.menuTool.AppendItem(self.menuRunFoamViewer)
        self.menuRunSalome = wx.MenuItem(self.menuTool, runSalomeID, u"SalomeMecaの起動", u"SalomeMecaを起動します", wx.ITEM_NORMAL)
        self.menuTool.AppendItem(self.menuRunSalome)
        self.frame_1_menubar.Append(self.menuTool, u"ツール")
        self.menuHelp = wx.Menu()
        self.menuUsage = wx.MenuItem(self.menuHelp, usageID, u"使い方", u"使い方の表示", wx.ITEM_NORMAL)
        self.menuHelp.AppendItem(self.menuUsage)
        self.menuVersion = wx.MenuItem(self.menuHelp, versionID, u"バージョン表示", "", wx.ITEM_NORMAL)
        self.menuHelp.AppendItem(self.menuVersion)
        self.frame_1_menubar.Append(self.menuHelp, u"ヘルプ")
        self.SetMenuBar(self.frame_1_menubar)
        # Menu Bar end
        self.frame_1_statusbar = self.CreateStatusBar(1, wx.ST_SIZEGRIP)
        self.static_line_7 = wx.StaticLine(self, -1)
        self.bitmap_button_1 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/changeRoot.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_2 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/reload.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_3 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/newCase.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_4 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/setCase.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_16 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/exit.png", wx.BITMAP_TYPE_ANY))
        self.static_line_4 = wx.StaticLine(self, -1, style=wx.LI_VERTICAL)
        self.combo_box_1 = wx.ComboBox(self, -1, choices=["startTime", "latestTime"], style=wx.CB_DROPDOWN)
        self.bitmap_button_5 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/editFields.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_19 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/dataSetClear.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_6 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/editProperties.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_7 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/editDict.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_8 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/editMesh.png", wx.BITMAP_TYPE_ANY))
        self.static_line_5 = wx.StaticLine(self, -1, style=wx.LI_VERTICAL)
        self.bitmap_button_13 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/runSolver.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_14 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/plotWatcher.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_15 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/parallel.png", wx.BITMAP_TYPE_ANY))
        self.static_line_1 = wx.StaticLine(self, -1, style=wx.LI_VERTICAL)
        self.bitmap_button_20 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/runCAD.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_10 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/runFoamTerm.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_11 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/runParaview.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_17 = wx.BitmapButton(self, -1, wx.Bitmap("/home/caeuser/TreeFoam/icons/salome_default.png", wx.BITMAP_TYPE_ANY))
        self.static_line_6 = wx.StaticLine(self, -1)
        self.label_1 = wx.StaticText(self, -1, u"    OpenFoam環境:", style=wx.ALIGN_RIGHT)
        self.label_6 = wx.StaticText(self, -1, "label_6")
        self.label_2 = wx.StaticText(self, -1, "  case directory:", style=wx.ALIGN_RIGHT)
        self.label_3 = wx.StaticText(self.panel_1, -1, "label_3")
        self.label_4 = wx.StaticText(self, -1, u" 現在の解析case名:", style=wx.ALIGN_RIGHT)
        self.button_1 = wx.Button(self.panel_2, -1, "open")
        self.label_5 = wx.StaticText(self.panel_2, -1, "label_5")
        self.button_2 = wx.Button(self.panel_2, -1, "open")
        self.label_7 = wx.StaticText(self.panel_2, -1, "label_7")
        #self.tree_ctrl_1 = wx.TreeCtrl(self, -1, style=wx.TR_HAS_BUTTONS|wx.TR_NO_LINES|wx.TR_DEFAULT_STYLE|wx.SUNKEN_BORDER)

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_MENU, self.selChangeRoot, self.menuChangeRoot)
        self.Bind(wx.EVT_MENU, self.selReload, self.menuReload)
        self.Bind(wx.EVT_MENU, self.selNewCase, self.menuNewCase)
        self.Bind(wx.EVT_MENU, self.selSetCurrCase, self.menuSetCurrCase)
        self.Bind(wx.EVT_MENU, self.selExit, self.menuExit)
        self.Bind(wx.EVT_MENU, self.selFolderOpen, self.menuFolderOpen)
        self.Bind(wx.EVT_MENU, self.selEditField, self.menuEditField)
        self.Bind(wx.EVT_MENU, self.selEditProperties, self.menuEditProperties)
        self.Bind(wx.EVT_MENU, self.selEditDict, self.menuEditDict)
        self.Bind(wx.EVT_MENU, self.selEditMesh, self.menuEditMesh)
        self.Bind(wx.EVT_MENU, self.selDataSetClear, self.menuDataSetClear)
        self.Bind(wx.EVT_MENU, self.selRenameCase, self.menuRenameCase)
        self.Bind(wx.EVT_MENU, self.selRunSolver, self.menuRunSolver)
        self.Bind(wx.EVT_MENU, self.selPlotWatcher, self.menuPlotWatcher)
        self.Bind(wx.EVT_MENU, self.selParalleleSolver, self.menuParalleleSolver)
        self.Bind(wx.EVT_MENU, self.selRunCAD, self.menuRunCAD)
        self.Bind(wx.EVT_MENU, self.selRunFoamTerm, self.menuRunFoamTerm)
        self.Bind(wx.EVT_MENU, self.selRunParaFoam, self.menuRunParaFoam)
        self.Bind(wx.EVT_MENU, self.selRunFoamViewer, self.menuRunFoamViewer)
        self.Bind(wx.EVT_MENU, self.selRunSalome, self.menuRunSalome)
        self.Bind(wx.EVT_MENU, self.selUsage, self.menuUsage)
        self.Bind(wx.EVT_MENU, self.selVersion, self.menuVersion)
        self.Bind(wx.EVT_BUTTON, self.onChangeRoot, self.bitmap_button_1)
        self.Bind(wx.EVT_BUTTON, self.onReload, self.bitmap_button_2)
        self.Bind(wx.EVT_BUTTON, self.onNewCase, self.bitmap_button_3)
        self.Bind(wx.EVT_BUTTON, self.onActiveCase, self.bitmap_button_4)
        self.Bind(wx.EVT_BUTTON, self.onExit, self.bitmap_button_16)
        self.Bind(wx.EVT_BUTTON, self.onEditField, self.bitmap_button_5)
        self.Bind(wx.EVT_BUTTON, self.onDataSetClear, self.bitmap_button_19)
        self.Bind(wx.EVT_BUTTON, self.onEditProperties, self.bitmap_button_6)
        self.Bind(wx.EVT_BUTTON, self.onEditDict, self.bitmap_button_7)
        self.Bind(wx.EVT_BUTTON, self.onEditMesh, self.bitmap_button_8)
        self.Bind(wx.EVT_BUTTON, self.onRunSolver, self.bitmap_button_13)
        self.Bind(wx.EVT_BUTTON, self.onPlotWatcher, self.bitmap_button_14)
        self.Bind(wx.EVT_BUTTON, self.onParallele, self.bitmap_button_15)
        self.Bind(wx.EVT_BUTTON, self.onRunCAD, self.bitmap_button_20)
        self.Bind(wx.EVT_BUTTON, self.onRunFoamTerm, self.bitmap_button_10)
        self.Bind(wx.EVT_BUTTON, self.onRunParaFoam, self.bitmap_button_11)
        self.Bind(wx.EVT_BUTTON, self.onRunSalome, self.bitmap_button_17)
        self.Bind(wx.EVT_BUTTON, self.onCaseOpen, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onCntDictOpen, self.button_2)
        self.Bind(wx.EVT_TREE_ITEM_ACTIVATED, self.onItemActivated, self.tree_ctrl_1)
        self.Bind(wx.EVT_TREE_ITEM_COLLAPSED, self.onItemCollapsed, self.tree_ctrl_1)
        self.Bind(wx.EVT_TREE_ITEM_EXPANDED, self.onItemExpanded, self.tree_ctrl_1)
        # end wxGlade
        self.Bind(wx.EVT_CLOSE, self.onCloseWindow)
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.onSelChanged, self.tree_ctrl_1)
        #self.Bind(wx.EVT_LEFT_DCLICK, self.onCaseOpen, self.label_7)
        #self.Bind(wx.EVT_LEFT_DCLICK, self.onCaseOpen, self.tree_ctrl_1)

        #----------------panel内のlabel（caseName, solverName）
        item = self.tree_ctrl_1.GetSelection()
        self.changeSolveCase(item)

        #----------------PopupMenu-------------
        self.popupmenu = wx.Menu()
        for text in self.setPopupMenuItems():
            item = self.popupmenu.Append(-1, text)
            self.Bind(wx.EVT_MENU, self.OnPopupItemSelected, item)
        self.Bind(wx.EVT_TREE_ITEM_RIGHT_CLICK, self.OnShowPopup, self.tree_ctrl_1)



    def __set_properties(self):
        global envOpenFOAMFix
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("TreeFoam")
        self.frame_1_statusbar.SetStatusWidths([-1])
        # statusbar fields
        frame_1_statusbar_fields = ["frame_1_statusbar"]
        for i in range(len(frame_1_statusbar_fields)):
            self.frame_1_statusbar.SetStatusText(frame_1_statusbar_fields[i], i)
        self.bitmap_button_1.SetMinSize((34, 34))
        self.bitmap_button_1.SetToolTipString(u"rootDirの変更")
        self.bitmap_button_2.SetMinSize((34, 34))
        self.bitmap_button_2.SetToolTipString(u"Dirの再読込")
        self.bitmap_button_3.SetMinSize((34, 34))
        self.bitmap_button_3.SetToolTipString(u"新規にcaseを作成")
        self.bitmap_button_4.SetMinSize((34, 34))
        self.bitmap_button_4.SetToolTipString(u"現在のcaseを解析caseとして設定")
        self.bitmap_button_16.SetMinSize((34, 34))
        self.bitmap_button_16.SetToolTipString(u"閉じる")
        self.combo_box_1.SetMinSize((130, 28))
        self.combo_box_1.SetSelection(-1)
        self.bitmap_button_5.SetMinSize((34, 34))
        self.bitmap_button_5.SetToolTipString(u"Fieldの編集")
        self.bitmap_button_19.SetMinSize((34, 34))
        self.bitmap_button_19.SetToolTipString(u"Fieldにデータをセット、又はクリアします")
        self.bitmap_button_6.SetMinSize((34, 34))
        self.bitmap_button_6.SetToolTipString(u"Propertiesの編集")
        self.bitmap_button_7.SetMinSize((34, 34))
        self.bitmap_button_7.SetToolTipString(u"Dict（system）の編集")
        self.bitmap_button_8.SetMinSize((34, 34))
        self.bitmap_button_8.SetToolTipString(u"meshの編集")
        self.bitmap_button_13.SetMinSize((34, 34))
        self.bitmap_button_13.SetToolTipString(u"solverを起動")
        self.bitmap_button_14.SetMinSize((34, 34))
        self.bitmap_button_14.SetToolTipString(u"plotWatcherの起動・停止")
        self.bitmap_button_15.SetMinSize((34, 34))
        self.bitmap_button_15.SetToolTipString(u"並列処理")
        self.bitmap_button_20.SetMinSize((34, 34))
        self.bitmap_button_20.SetToolTipString(u"CADの起動")
        self.bitmap_button_10.SetMinSize((34, 34))
        self.bitmap_button_10.SetToolTipString(u"FOAM端末の起動")
        self.bitmap_button_11.SetMinSize((34, 34))
        self.bitmap_button_11.SetToolTipString(u"paraFoamの起動")
        self.bitmap_button_17.SetMinSize((34, 34))
        self.bitmap_button_17.SetToolTipString(u"SalomeMecaの起動")
        self.label_1.SetMinSize((117, 19))
        self.label_2.SetMinSize((120, 17))
        self.panel_1.SetBackgroundColour(wx.Colour(233, 255, 240))
        self.label_4.SetMinSize((120, 17))
        self.button_1.SetMinSize((35, 21))
        self.button_1.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "VL ゴシック"))
        self.label_5.SetFont(wx.Font(10, wx.TELETYPE, wx.NORMAL, wx.BOLD, 0, "VL ゴシック"))
        self.button_2.SetMinSize((35, 21))
        self.button_2.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "VL ゴシック"))
        self.panel_2.SetBackgroundColour(wx.Colour(233, 255, 240))
        # end wxGlade
        self.SetTitle("TreeFoam_" + version + " (" + nTreeFoam + ")")
        self.clearStatus()
        self.readConfig()
        self.getConfig()
        self.setSolverInLabel("")
        getTreeDirUntilCurrCase(rootDir, selCaseDir)

        self.tree_ctrl_1 = wx.gizmos.TreeListCtrl(self, -1,
            style=
                wx.TR_DEFAULT_STYLE|
                wx.TR_FULL_ROW_HIGHLIGHT|
                wx.TR_HAS_BUTTONS|
                wx.SUNKEN_BORDER|
                wx.TR_HAS_BUTTONS)
        self.tree_ctrl_1.AddColumn("Tree")
        self.tree_ctrl_1.AddColumn("solver")
        self.tree_ctrl_1.AddColumn("nR")
        self.tree_ctrl_1.AddColumn("st")
        self.tree_ctrl_1.AddColumn("ed")
        self.tree_ctrl_1.SetMainColumn(0)
        self.tree_ctrl_1.SetColumnWidth(0, 300)
        self.tree_ctrl_1.SetColumnWidth(1, 200)
        self.tree_ctrl_1.SetColumnWidth(2, 40)
        self.tree_ctrl_1.SetColumnWidth(3, 60)
        self.tree_ctrl_1.SetColumnWidth(4, 60)
        self.tree_ctrl_1.SetMinSize((700, 50))
        self.tree_ctrl_1.SetBackgroundColour(wx.Colour(229, 229, 229))

        #imageセット
        ilist = wx.ImageList(16,16)
        self.fldridx = ilist.Add(
            wx.ArtProvider.GetBitmap(wx.ART_FOLDER, wx.ART_OTHER, (16,16)))
        self.fldropenidx = ilist.Add(
            wx.ArtProvider.GetBitmap(wx.ART_FILE_OPEN, wx.ART_OTHER, (16,16)))
        self.fileidx = ilist.Add(
            wx.ArtProvider.GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, (16,16)))
        self.OFidx = ilist.Add(
            wx.ArtProvider.GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, (16,16)))
        self.OFsolveridx = ilist.Add(
            wx.ArtProvider.GetBitmap(wx.ART_FILE_OPEN, wx.ART_OTHER, (16,16)))
        self.SolveCaseidx = ilist.Add(
            wx.ArtProvider.GetBitmap(wx.ART_TICK_MARK, wx.ART_OTHER, (16,16)))
        self.tree_ctrl_1.AssignImageList(ilist)
        #treeDataのセット
        root = self.tree_ctrl_1.AddRoot(treeData[0])
        rootName = self.tree_ctrl_1.GetItemText(root)
        data = self.setValue()
        self.AddTreeNodes(root, data)
        self.tree_ctrl_1.SetItemImage(root, self.fldridx,
            wx.TreeItemIcon_Normal)
        caseDir = selCase
        self.setInitialImage(caseDir)
        self.setSelectCase(caseDir)
        #OpenFOAM環境設定ファイル表示
        self.label_6.SetLabel(" " + envOpenFOAMFix)



    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.static_line_7, 0, wx.BOTTOM|wx.EXPAND, 4)
        sizer_11.Add(self.bitmap_button_1, 0, wx.BOTTOM, 0)
        sizer_11.Add(self.bitmap_button_2, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_3, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_4, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_16, 0, 0, 0)
        sizer_11.Add(self.static_line_4, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 4)
        sizer_11.Add(self.combo_box_1, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_11.Add(self.bitmap_button_5, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_19, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_6, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_7, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_8, 0, 0, 0)
        sizer_11.Add(self.static_line_5, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 4)
        sizer_11.Add(self.bitmap_button_13, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_14, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_15, 0, 0, 0)
        sizer_11.Add(self.static_line_1, 0, wx.LEFT|wx.RIGHT|wx.EXPAND, 4)
        sizer_11.Add(self.bitmap_button_20, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_10, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_11, 0, 0, 0)
        sizer_11.Add(self.bitmap_button_17, 0, 0, 0)
        sizer_1.Add(sizer_11, 0, wx.EXPAND, 0)
        sizer_1.Add(self.static_line_6, 0, wx.TOP|wx.BOTTOM|wx.EXPAND, 4)
        sizer_12.Add(self.label_1, 0, wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_12.Add(self.label_6, 0, 0, 0)
        sizer_1.Add(sizer_12, 0, wx.EXPAND, 0)
        sizer_4.Add(self.label_2, 0, wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_8.Add(self.label_3, 0, 0, 0)
        self.panel_1.SetSizer(sizer_8)
        sizer_6.Add(self.panel_1, 1, wx.EXPAND, 0)
        sizer_4.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_4.Add((5, 20), 0, 0, 0)
        sizer_1.Add(sizer_4, 0, wx.EXPAND, 0)
        sizer_5.Add(self.label_4, 0, wx.ALIGN_RIGHT|wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_9.Add(self.button_1, 0, 0, 0)
        sizer_9.Add(self.label_5, 0, 0, 0)
        sizer_9.Add((20, 20), 0, 0, 0)
        sizer_3.Add(self.button_2, 0, 0, 0)
        sizer_3.Add(self.label_7, 0, 0, 0)
        sizer_3.Add((10, 20), 0, 0, 0)
        sizer_9.Add(sizer_3, 1, wx.EXPAND|wx.ALIGN_RIGHT|wx.SHAPED, 0)
        self.panel_2.SetSizer(sizer_9)
        sizer_7.Add(self.panel_2, 1, wx.EXPAND, 0)
        sizer_5.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_5.Add((5, 20), 0, 0, 0)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_1.Add((500, 5), 0, 0, 0)
        sizer_2.Add((5, 300), 0, 0, 0)
        sizer_2.Add(self.tree_ctrl_1, 1, wx.RIGHT|wx.EXPAND, 0)
        sizer_2.Add((5, 100), 0, 0, 0)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_1.Add((100, 5), 0, 0, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #------menu bar ----------------------
    def selChangeRoot(self, event): # wxGlade: MyFrame.<event_handler>
        self.writeStatus(u"rootDirを変更中...")
        root = self.tree_ctrl_1.GetRootItem()
        editName = self.tree_ctrl_1.GetItemText(root)
        self.changeRoot(editName)
        self.clearStatus()
        event.Skip()

    def selExit(self, event): # wxGlade: MyFrame.<event_handler>
        try:
            self.writeConfig()
        except:
            title = "エラー"
            message = "書込エラーが発生しました。\n  強制終了します。"
            self.errDialog(title, message)
        endingTreeFoam()
        frame_1.Destroy()

    def selReload(self, event): # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, selCaseDirFix
        self.writeStatus(u"tree data を読み込み中...")
        #currentCaseを保存
        item = self.tree_ctrl_1.GetSelection()
        selCaseDir = self.getDirectory(item)
        #再読込
        self.reloadItems()
        #caseName, solverをlabelにセット
        caseItem = self.getItem(solveCaseFix)
        self.changeSolveCase(caseItem)
        #currentCaseを設定
        self.setSelectCase(self.convDirToList(selCaseDir))
        self.clearStatus()
        event.Skip()

    def selUsage(self, event): # wxGlade: MyFrame.<event_handler>
        print "ヘルプを表示します。"
        treeFoamDir = getTreeFoamInstallDir()
        #firefox終了時エラーが出るので、firefoxのエラー表示をキャンセル
        command = "firefox " + treeFoamDir + "/help/TreeFoam-manual.pdf 2> null &"
        os.system(command)

    def selVersion(self, event): # wxGlade: MyFrame.<event_handler>
        global version
        print "versionを表示します。"
        title = u"version表示"
        message = u"TreeFoamのバージョンを表示します。\n\n"
        message += u"  TreeFoam " + version
        message += "\n\n\n                programed by s.fujii  "
        self.okDialog(title, message)

    def selNewCase(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `selNewCase' not implemented"
        event.Skip()

    def selSetCurrCase(self, event): # wxGlade: MyFrame.<event_handler>
        item = self.tree_ctrl_1.GetSelection()
        self.changeSolveCase(item)
        event.Skip()

    def selEditField(self, event): # wxGlade: MyFrame.<event_handler>
        global nTreeFoam
        if self.checkFolderMsg(solveCaseFix) == "case":
            os.chdir(solveCaseFix)
            Num = self.combo_box_1.GetSelection()
            NumFolder = self.combo_box_1.GetString(Num)
            editDir = solveCaseFix + "/" + NumFolder
            FFlist = setEditFolders(editDir)
            #frame_1.Destroy()
            job = "editField"
            title = "boundary Field の編集"
            img = "boundary"
            mess = u"「" + NumFolder.encode("utf-8") + u"」の boundary Field を編集します"
            selectFieldsForEditDialog.Show(nTreeFoam, job, title, img, mess, FFlist, editDir)
            #pyOFLauncher.editFields()
        event.Skip()

    def selEditProperties(self, event): # wxGlade: MyFrame.<event_handler>
        if self.checkFolderMsg(solveCaseFix) == "case":
            os.chdir(solveCaseFix)
            pyOFLauncher.editPropertiesFiles()
        event.Skip()

    def selEditDict(self, event): # wxGlade: MyFrame.<event_handler>
        if self.checkFolderMsg(solveCaseFix) == "case":
            os.chdir(solveCaseFix)
            pyOFLauncher.editDict()
        event.Skip()

    def selEditMesh(self, event): # wxGlade: MyFrame.<event_handler>
        if self.checkFolderMsg(solveCaseFix) == "case":
            os.chdir(solveCaseFix)
            meshOperationDialog.Show()
        event.Skip()

    def selRenameCase(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `selRenameCase' not implemented"
        event.Skip()

    def selRunSolver(self, event): # wxGlade: MyFrame.<event_handler>
        self.runSolver(solveCaseFix)
        event.Skip()

    def selPlotWatcher(self, event): # wxGlade: MyFrame.<event_handler>
        self.onPlotWatcher(event)

    def selParalleleSolver(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `selParalleleSolver' not implemented"
        event.Skip()

    def selRunFoamTerm(self, event): # wxGlade: MyFrame.<event_handler>
        global solveCaseFix
        self.runFoamTermDir(solveCaseFix)
        event.Skip()

    def selRunParaFoam(self, event): # wxGlade: MyFrame.<event_handler>
        self.onRunParaFoam(event)
        event.Skip()

    def selRunFoamViewer(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `selRunFoamViewer' not implemented"
        event.Skip()

    def selRunSalome(self, event): # wxGlade: MyFrame.<event_handler>
        self.runSalomeMeca(solveCaseFix)
        event.Skip()

    def selFolderOpen(self, event): # wxGlade: MyFrame.<event_handler>
        self.onFolderOpen(event)
        event.Skip()

    def selDataSetClear(self, event): # wxGlade: MyFrame.<event_handler>
        if self.checkFolderMsg(solveCaseFix) == "case":
            os.chdir(solveCaseFix)
            num = self.combo_box_1.GetSelection()
            timeFolder = self.combo_box_1.GetString(num)
            setDataInFieldsDialog.Show(solveCaseFix, timeFolder)
        event.Skip()

    def selRunCAD(self, event): # wxGlade: MyFrame.<event_handler>
        self.runCAD(solveCaseFix)
        event.Skip()

    #setSolverInLabel
    def setSolverInLabel(self, solver):
        #最大文字数
        maxChara = 30
        label = solver
        i=len(solver)
        while i<maxChara:
            label += " "
            i+=1
        self.label_7.SetLabel(label)

    # checkFolderMesg
    def checkFolderMsg(self, directory):
        ans = checkFolder(solveCaseFix)
        if ans != "case":
            title = u"警告"
            message = u"OpenFOAMのCaseフォルダではありません。"
            self.warningDialog(title, message)
        return ans

    # AddTreeNode
    def AddTreeNodes(self, parentItem, items):
        for item in items:
            #if type(item) == str:
            if type(item) == str or type(item) == unicode:
                newItem = self.tree_ctrl_1.AppendItem(parentItem, item)
                self.tree_ctrl_1.SetItemImage(newItem, self.fldridx,
                    wx.TreeItemIcon_Normal)
            else:
                newItem = self.tree_ctrl_1.AppendItem(parentItem, item[0])
                self.AddTreeNodes(newItem, item[1])
                self.tree_ctrl_1.SetItemImage(newItem, self.fldridx,
                    wx.TreeItemIcon_Normal)

    #
    # setValue
    #   treeのデータ構造
    #    ['root', [
    #        '0', 
    #        ['constant', [
    #             ['polyMesh', [
    #                'sets',
    #                'sets.bak',
    #                'sss']]]], 
    #        'model',
    #        'solve.log.analyzed', 
    #        ['system', [
    #            'test']]]]
    #
    def setValue(self):
        global treeData
        data = treeData[1]
        return data

    # setSelectCase
    #  treeDataからcurrentCaseをselectする
    def setSelectCase(self, dataDir):
        i=0
        while (i<len(dataDir)):
            if type(dataDir[i]) == str:
                dataDir[i] = dataDir[i].decode("utf-8")
            i=i+1
        parent = self.tree_ctrl_1.GetRootItem()
        #name = self.tree_ctrl_1.GetItemText(parent)
        i=1
        while (i<len(dataDir)):
            self.tree_ctrl_1.Expand(parent)
            #全chilrenをチェック
            items = self.getChildrenItems(parent)
            itemNames = self.getChildrenList(parent)
            ii=0
            while ii<len(itemNames):
                if type(itemNames[ii]) == str:
                    itemNames[ii] = itemNames[ii].decode("utf-8")
                ii=ii+1
            flag = 0
            ii=0
            while ii<len(itemNames):
                if itemNames[ii] == dataDir[i]:
                    parent = items[ii]
                    flag = 1
                    break
                ii=ii+1
            if flag == 0:
                print dataDir, "のDirがありません。"
                break
            i=i+1
        self.tree_ctrl_1.SelectItem(parent, parent, True)
        item = self.tree_ctrl_1.GetSelection()
        #self.tree_ctrl_1.EnsureVisible(item)
        self.tree_ctrl_1.ScrollTo(item)

    # setInitialImage
    #  TreeDataにイメージデータを設定
    def setInitialImage(self, caseDir):
        global solveCaseFix
        parent = self.tree_ctrl_1.GetRootItem()
        parentName = self.tree_ctrl_1.GetItemText(parent)
        setDir = parentName
        for folder in caseDir[1:]:
            #parentのchildren[]を取得
            children = self.getChildrenList(parent)
            #全childrenをチェック
            item, cookie = self.tree_ctrl_1.GetFirstChild(parent)
            for child in children:
                checkDir = setDir + "/" + child
                if (checkFolder(checkDir) == "case"):
                    itemOF = item
                    solver = getSolver(checkDir)
                    nRst = getNumberResult(checkDir)
                    self.setItemOFImage(itemOF, solver, nRst)
                item, cookie = self.tree_ctrl_1.GetNextChild(parent, cookie)
            item, cookie = self.tree_ctrl_1.GetFirstChild(parent)
            for child in children:
                parentName = ""
                if type(folder) == str:
                    folder = folder.decode("utf-8")
                if folder == child:
                    parent = item
                    parentName = self.tree_ctrl_1.GetItemText(parent)
                    setDir = setDir + "/" + parentName
                    break
                item, cookie = self.tree_ctrl_1.GetNextChild(parent, cookie)
            if parentName == "":
                break

    # setChildrenImage
    #  childrenにイメージをセット
    def setChildrenImage(self, parent):
        childrenItems = self.getChildrenItems(parent)
        for childItem in childrenItems:
            checkDir = self.getDirectory(childItem)
            if (checkFolder(checkDir) == "case"):
                solver = getSolver(checkDir)
                nRst = getNumberResult(checkDir)
                self.setItemOFImage(childItem, solver, nRst)                

    # setItemOFImage
    #  OpenFoamのImageをセット
    def setItemOFImage(self, itemOF, solver, nRst):
        self.tree_ctrl_1.SetItemImage(itemOF, self.OFidx, 0,
            wx.TreeItemIcon_Normal)
        self.tree_ctrl_1.SetItemText(itemOF, solver, 1)
        self.tree_ctrl_1.SetItemImage(itemOF, self.OFsolveridx,1,
            wx.TreeItemIcon_Normal)
        if len(nRst)>0:
            self.tree_ctrl_1.SetItemText(itemOF, nRst[0], 2)
            self.tree_ctrl_1.SetItemText(itemOF, nRst[1], 3)
            self.tree_ctrl_1.SetItemText(itemOF, nRst[2], 4)

    # getItem
    #  directoryからTreeItemを取得
    def getItem(self, directory):
        global rootDir
        treeDir = directory[len(rootDir)+1:].split("/")
        parent = self.tree_ctrl_1.GetRootItem()
        for name in treeDir:
            childrenItem = self.getChildrenItems(parent)
            flag = 0
            for item in childrenItem:
                child = self.tree_ctrl_1.GetItemText(item)
                if name == child:
                    flag = 1
                    break
            if flag == 1:
                parent = item
            else:
                ans = ""
                break
        ans = item
        return ans

    # getDirectory
    #  TreeDataからdirectoryを取得
    def getDirectory(self, item):
        name = self.tree_ctrl_1.GetItemText(item)
        selectDir = ""
        while (name != ""):
            selectDir = "/" + name + selectDir
            item = self.tree_ctrl_1.GetItemParent(item)
            name = self.tree_ctrl_1.GetItemText(item)
        selectDir = selectDir[1:]
        return selectDir

    # getChildrenList
    #  親itemから子のtextを取得
    def getChildrenList(self, parent):
        children = []
        #firstChild
        item, cookie = self.tree_ctrl_1.GetFirstChild(parent)
        while item:
            children.append(self.tree_ctrl_1.GetItemText(item, 0))
            #nextChild
            item, cookie = self.tree_ctrl_1.GetNextChild(parent, cookie)
        return children

    #
    #  getChildrenItems
    #    親itemから子itemを取得
    def getChildrenItems(self, parent):
        items = []
        #firstChild
        item, cookie = self.tree_ctrl_1.GetFirstChild(parent)
        while item:
            items.append(item)
            #nextChild
            item, cookie = self.tree_ctrl_1.GetNextChild(parent, cookie)
        return items


    #
    #  addGrandChildren
    #    親itemから孫itemを追加
    def addGrandChildren(self, parent):
        childrenItems = self.getChildrenItems(parent)
        for childItem in childrenItems:
            directory = self.getDirectory(childItem)
            folders = getFoldersOnlyCurrDir(directory)
            folders.sort()
            for folder in folders:
                itemText = folder.split("/")[-1]
                check = checkFolder(folder)
                if (check == "folder"):
                    newItem = self.tree_ctrl_1.AppendItem(childItem, itemText)
                    self.tree_ctrl_1.SetItemImage(newItem, self.fldridx,
                        wx.TreeItemIcon_Normal)
                elif (check == "case"):
                    newItem = self.tree_ctrl_1.AppendItem(childItem, itemText)
                    solver = getSolver(folder)
                    nRst = getNumberResult(folder)
                    self.setItemOFImage(newItem, solver, nRst)

    #
    #  delGrandChildrenItem
    #    孫itemの削除
    def delGrandChildrenItem(self, parent):
        children = self.getChildrenItems(parent)
        for childItem in children:
            self.tree_ctrl_1.DeleteChildren(childItem)

    def collapseChildren(self, parent):
        children = self.getChildrenItems(parent)
        for childItem in children:
            self.tree_ctrl_1.Collapse(childItem)

    def reloadItems(self):
        global rootDir, selCaseDir, treeData
        #treeをクリア
        self.writeStatus(u"tree data を読み込み中...")
        self.tree_ctrl_1.DeleteAllItems()
        #rootのdirを取得
        self.getConfig()
        selCaseDir = rootDir
        getTreeDirOnlylRootChildren(rootDir)
        root = self.tree_ctrl_1.AddRoot(treeData[0])
        rootName = self.tree_ctrl_1.GetItemText(root)
        #treeDataの作成
        data = treeData[1]
        self.AddTreeNodes(root, data)
        self.tree_ctrl_1.SetItemImage(root, self.fldridx,
            wx.TreeItemIcon_Normal)
        #selCaseの設定
        self.getConfig()
        caseDir = self.convDirToList(selCaseDir)
        self.setInitialImage(caseDir)
        self.setSelectCase(caseDir)
        self.setSolveCase()
        item = self.tree_ctrl_1.GetSelection()
        self.tree_ctrl_1.ScrollTo(item)
        item = self.getItem(solveCaseFix)
        self.tree_ctrl_1.SetItemImage(item, self.SolveCaseidx, 0,
            wx.TreeItemIcon_Normal)
        #編集するtimeFolderを設定
        self.setEditTimeFolder(solveCaseFix)
        #solverを設定
        #solver = getSolver(selCaseDir)
        #self.label_7.SetLabel(solver)

    def convDirToList(self, dataDir):
        global rootDir
        ans = []
        dataNames = dataDir[len(rootDir)+1:].split("/")
        ans.append(rootDir)
        for name in dataNames:
            ans.append(name)
        return ans

    def setSolveCase(self):
        global solveCaseFix, rootDir
        saveItem =  self.tree_ctrl_1.GetSelection()
        caseDir = self.convDirToList(solveCaseFix)
        self.setSelectCase(caseDir)
        item = self.tree_ctrl_1.GetSelection()
        self.tree_ctrl_1.SetItemTextColour(item, "Red")
        self.tree_ctrl_1.SetItemBold(item, True)
        self.tree_ctrl_1.SelectItem(saveItem, saveItem, True)    

    #
    #  changeSolveCase
    #    解析caseを変更
    def changeSolveCase(self, item):
        global solveCaseFix, rootDir, timeFolders
        #変更前の解析Caseのfont色を元に戻す
        caseDir = self.convDirToList(solveCaseFix)
        self.setSelectCase(caseDir)
        preItem = self.tree_ctrl_1.GetSelection()
        self.tree_ctrl_1.SetItemTextColour(preItem, "#4c4c4c")      #system色（黒）
        self.tree_ctrl_1.SetItemBold(preItem, False)
        #変更前のiconを元に戻す
        preDir = self.getDirectory(preItem)
        if checkFolder(preDir) == "case":
            self.tree_ctrl_1.SetItemImage(preItem, self.OFidx,0,
                wx.TreeItemIcon_Normal)
        else:
            self.tree_ctrl_1.SetItemImage(preItem, self.fldridx,0,
                wx.TreeItemIcon_Normal)
        #解析Caseのfontを変更
        solveDir = self.getDirectory(item)
        self.setSelectCase(self.convDirToList(solveDir))
        self.tree_ctrl_1.SetItemTextColour(item, "Red")  #ff0000
        #self.tree_ctrl_1.SetItemTextColour(item, "#ff0000")  #ff0000
        self.tree_ctrl_1.SetItemBold(item, True)
        #解析Caseのiconを設定
        self.tree_ctrl_1.SetItemImage(item, self.SolveCaseidx,0,
            wx.TreeItemIcon_Normal)
        #labeにdirectoryとcase、solver名を記入
        solveCaseFix = solveDir
        caseName = solveCaseFix.split("/")[-1]
        caseDir = solveCaseFix[:-len(caseName)-1]
        solver = getSolver(solveDir)
        maxCharaLength = 85
        if len(caseDir) > maxCharaLength:
            caseDir = "..." + caseDir[-(maxCharaLength-3):]
        self.label_3.SetLabel(" " + caseDir)
        self.label_5.SetLabel(caseName)
        self.setSolverInLabel(solver)
        #labelのbackGroundColorを設定
        if self.checkFolderMsg(solveCaseFix) == "case":
            #lightGreenに設定
            self.panel_1.SetBackgroundColour(wx.Colour(233, 255, 240))
            self.panel_2.SetBackgroundColour(wx.Colour(233, 255, 240))
        else:
            #pinkに設定
            self.panel_1.SetBackgroundColour(wx.Colour(255, 233, 240))
            self.panel_2.SetBackgroundColour(wx.Colour(255, 233, 240))
        #時間フォルダの取得、設定
        self.setEditTimeFolder(solveCaseFix)

    #
    #  setEditTimeFolder
    #    編集するtimeFolderの設定
    def setEditTimeFolder(self, solveCaseFix):
        timeFolders = getResultTimeFolders(solveCaseFix)
        self.combo_box_1.Clear()
        for text in timeFolders:
            self.combo_box_1.Append(text)
        wdir = solveCaseFix+"/system"
        startFrom = getFoamContents.controlDict(wdir, ["startFrom"])
        if startFrom != None:
            if startFrom[0] == "startTime":
                self.combo_box_1.SetSelection(0)
            elif startFrom[0] == "latestTime":
                self.combo_box_1.SetSelection(len(timeFolders)-1)
        else:
            self.combo_box_1.SetSelection(0)

    #--------メニューボタン-------------------
    def onChangeRoot(self, event): # wxGlade: MyFrame.<event_handler>
        self.selChangeRoot(event)
        event.Skip()

    def onReload(self, event): # wxGlade: MyFrame.<event_handler>
        self.selReload(event)
        event.Skip()

    def onNewCase(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `onNewCase' not implemented"
        event.Skip()

    def onActiveCase(self, event): # wxGlade: MyFrame.<event_handler>
        self.selSetCurrCase(event)
        event.Skip()

    def onEditField(self, event): # wxGlade: MyFrame.<event_handler>
        self.selEditField(event)
        event.Skip()

    def onEditProperties(self, event): # wxGlade: MyFrame.<event_handler>
        self.selEditProperties(event)
        event.Skip()

    def onEditDict(self, event): # wxGlade: MyFrame.<event_handler>
        self.selEditDict(event)
        event.Skip()

    def onEditMesh(self, event): # wxGlade: MyFrame.<event_handler>
        self.selEditMesh(event)
        event.Skip()

    def onRunSalome(self, event): # wxGlade: MyFrame.<event_handler>
        self.selRunSalome(event)
        event.Skip()

    def onChangeCase(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `onChangeCase' not implemented"
        event.Skip()

    def onRunSolver(self, event): # wxGlade: MyFrame.<event_handler>
        self.selRunSolver(event)
        event.Skip()

    def onPlotWatcher(self, event): # wxGlade: MyFrame.<event_handler>
        self.runPlotWatcher()

    def onParallele(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `onParallele' not implemented"
        event.Skip()

    def onRunFoamTerm(self, event): # wxGlade: MyFrame.<event_handler>
        global solveCaseFix
        self.runFoamTermDir(solveCaseFix)
        event.Skip()

    def onRunParaFoam(self, event): # wxGlade: MyFrame.<event_handler>
        global solveCaseFix
        self.runParaFoamDir(solveCaseFix)
        event.Skip()

    def onRunViewer(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `onRunViewer' not implemented"
        event.Skip()

    def onExit(self, event): # wxGlade: MyFrame.<event_handler>
        self.selExit(event)

    def onFolderOpen(self, event): # wxGlade: MyFrame.<event_handler>
        global solveCaseFix
        os.system("nautilus --browser " + solveCaseFix)
        event.Skip()

    def onDataSetClear(self, event): # wxGlade: MyFrame.<event_handler>
        self.selDataSetClear(event)
        event.Skip()

    def onRunCAD(self, event): # wxGlade: MyFrame.<event_handler>
        self.selRunCAD(event)
        event.Skip()

    def onCaseOpen(self, event): # wxGlade: MyFrame.<event_handler>
        self.onFolderOpen(event)
        event.Skip()

    def onCntDictOpen(self, event): # wxGlade: MyFrame.<event_handler>
        global solveCaseFix
        if self.checkFolderMsg(solveCaseFix) == "case":
            comm = "gedit --new-window " + solveCaseFix + "/system/controlDict "
            comm += solveCaseFix + "/system/fvSchemes "
            comm += solveCaseFix + "/system/fvSolution &"
            os.system(comm)
        event.Skip()

    #--------event menu ---------------------
    def onItemActivated(self, event): # wxGlade: MyFrame.<event_handler>
        self.onItemOpen(event)
        #event.Skip()

    def onItemCollapsed(self, event): # wxGlade: MyFrame.<event_handler>
        collItem = event.GetItem()
        rootItem = self.tree_ctrl_1.GetRootItem()
        selItem = self.tree_ctrl_1.GetSelection()
        if collItem == rootItem:
            self.tree_ctrl_1.SelectItem(rootItem, rootItem, True)
        if selItem == rootItem:
            parent = rootItem
        else:
            parent = self.tree_ctrl_1.GetItemParent(selItem)
        while parent != rootItem:
            if parent == collItem:
                self.tree_ctrl_1.SelectItem(parent, parent, True)
                break
            parent = self.tree_ctrl_1.GetItemParent(parent)
#        self.tree_ctrl_1.ScrollTo(collItem)
        #孫item削除
        self.delGrandChildrenItem(collItem)
        event.Skip()

    def onItemExpanded(self, event): # wxGlade: MyFrame.<event_handler>
        self.writeStatus(u"childrenItemsを展開中...")
        parent = event.GetItem()
        #parentの子itemのイメージをセット
        self.setChildrenImage(parent)
        #parentの孫itemを追加（孫が
        self.addGrandChildren(parent)
        #子itemを折りたたむ
        self.collapseChildren(parent)
        self.clearStatus()
        event.Skip()

    def onSelChanged(self, event):
        item = self.tree_ctrl_1.GetSelection()
        selectDir = self.getDirectory(item)
        if (checkFolder(selectDir) == "case"):
            solver = getSolver(selectDir)
            nRst = getNumberResult(selectDir)
            self.setItemOFImage(item, solver, nRst)
            if selectDir == solveCaseFix:
                self.setSolverInLabel(solver)
        #directory = self.getDirectory(item)
        if selectDir == solveCaseFix:
            self.tree_ctrl_1.SetItemImage(item, self.SolveCaseidx, 0,
                wx.TreeItemIcon_Normal)
        self.saveSelCaseDirToConfig(selectDir)            #selectDirを保存
        event.Skip()

    def onItemOpen(self, event):
        print "フォルダをopenします。"
        item = self.tree_ctrl_1.GetSelection()
        directory = self.getDirectory(item)
        os.system(("nautilus --browser " + directory).encode("utf-8"))
        #self.onSelChanged(event)
        #self.onFolderOpen(event)

    def onCloseWindow(self, event):
        #self.writeConfig()
        self.Destroy()

    #------------Popup menu-------------
    # setPopupMenuItems
    #  ポップアップメニュー項目設定
    def setPopupMenuItems(self):
        menu = u"開く FOAM端末の起動 解析caseとして設定 フォルダ追加 フォルダ削除 フォルダ名修正"
        menu = menu.split()
        return menu

    #
    # OnShowPopup
    #  ポップアップメニュー表示
    def OnShowPopup(self, event):
        item = event.GetItem()
        self.tree_ctrl_1.SelectItem(item, item, True)
        #self.onItemActivated(event)
        pos = event.GetPoint()
        self.tree_ctrl_1.PopupMenu(self.popupmenu, pos)

    def OnPopupItemSelected(self, event):
        global selCaseDir, editName, childrenList, rootDir
        PPitem = self.popupmenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #開く
        if (text == u"開く"):
            item = self.tree_ctrl_1.GetSelection()
            directory = self.getDirectory(item)
            os.system(("nautilus --browser " + directory).encode("utf-8"))
        #FOAM端末の起動
        elif (text == u"FOAM端末の起動"):
            self.runFoamTerm()
        #解析caseとして設定
        elif (text == u"解析caseとして設定"):
            item = self.tree_ctrl_1.GetSelection()
            self.changeSolveCase(item)
        #フォルダ追加
        elif (text == u"フォルダ追加"):
            print "フォルダを追加します"
            self.writeStatus(u"フォルダを作成中...")
            item = self.tree_ctrl_1.GetSelection()
            parent = self.tree_ctrl_1.GetItemParent(item)
            parentDir = self.getDirectory(parent)
            folderName = parentDir + "/newFolder"
            n = 0
            error = "NG"
            while error == "NG":
                newFolderName = folderName + "_" + str(n)
                try:
                    os.mkdir(newFolderName)
                    error = "OK"
                except:
                    n += 1
            self.reloadItems()
            self.clearStatus()
            newItem = self.getItem(newFolderName)
            self.tree_ctrl_1.SelectItem(newItem, newItem, True)
            self.renameFolder()
        #フォルダ削除
        elif (text == u"フォルダ削除"):
            print "フォルダを削除します"
            self.writeStatus(u"フォルダを作成中...")
            item = self.tree_ctrl_1.GetSelection()
            delDir = self.getDirectory(item)
            title = u"フォルダの削除"
            mess = u"フォルダ「" + delDir + u"」を削除します"
            ans = self.okCancelDialog(title, mess)
            if ans == "OK":
                try:
                    shutil.rmtree(delDir)
                except:
                    print "フォルダが削除できませんでした"
            self.reloadItems()
            self.clearStatus()
        #フォルダ名修正
        elif (text == u"フォルダ名修正"):
            self.renameFolder()

    def renameFolder(self):
        global selCaseDir, editName, childrenList, rootDir
        self.writeStatus(u"フォルダ名を変更中...")
        item = self.tree_ctrl_1.GetSelection()
        editName = self.tree_ctrl_1.GetItemText(item)
        if editName == rootDir:
            self.changeRoot(editName)
        else:
            parent = self.tree_ctrl_1.GetItemParent(item)
            childrenList = self.getChildrenList(parent)
            #self.tree_ctrl_1.EditLabel(item)
            text = self.textDialog("dir名の変更", "変更するdir名を入力してください。", editName)
            if text != "":
                flag = 0
                for name in childrenList:
                    if name == text:
                        if name != editName:
                            msg = "フォルダ内に同じ名前があります。"
                            self.errDialog("エラー", msg)
                        flag = 1
                        break
                if flag == 0:
                    self.tree_ctrl_1.SetItemText(item, text)
                    parentDir = self.getDirectory(parent)
                    editDir = parentDir + "/" + editName
                    textDir = parentDir + "/" + text
                    comm = "mv " + editDir + " " + textDir
                    a = os.system(comm)
                    selCaseDir = textDir
                    self.saveSelCaseDirToConfig(selCaseDir)
                    self.reloadItems()
        self.clearStatus()

    def changeRoot(self, editName):
        text = self.textDialog("rootの変更", "変更するrootDirを入力してください。", editName)
        if text != "":
            newName = glob.glob(text)
            if len(newName) == 1:
                self.saveRootDirToConfig(newName[0])
                self.reloadItems()
                msg = u"rootDirを変更しました。"
                self.okDialog(u"rootDirの変更", msg)
            else:
                msg = text + u" のフォルダは存在しません。"
                self.errDialog(u"エラー", msg)

    def runSolver(self, directory):
        global envOpenFOAMFix
        if self.checkApp(directory, envOpenFOAMFix) == "OK":
            solver = getSolver(directory)
            if solver != "":
                #dir移動
                saveDir = os.getcwd()
                os.chdir(directory)
                #solve.logのクリア
                f=open("solve.log","w")
                f.close()
                #solverの実行ファイル作成
                caseName = directory.split("/")[-1]
                title =  "#!/bin/bash\n"
                envSet = ". " + envOpenFOAMFix + "\n"
                solverSet = solver + " | tee solve.log\n"
                cont = title + envSet + solverSet
                f=open("run","w")
                f.write(cont)
                f.close()
                #実行権付与
                os.system("chmod a+x run")
                #実行
                comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run"
                os.system(comm)
                #dirを元に戻す
                os.chdir(saveDir)
            else:
                title = "エラー"
                message = "「controlDict」は、存在しません。\n"
                message = message + "case directory が間違っています。"
                self.errDialog(title, message)
        else:
            title = "エラー"
            message = "環境設定file「bashrcFOAM」が存在しない為、FOAM端末が起動できません。\n"
            message = message + "　　configTreeFoamファイルの内容を確認してください。"
            self.errDialog(title, message)

    def runPlotWatcher(self):
        global solveCaseFix, envOpenFOAMFix
        if self.checkApp(solveCaseFix, envOpenFOAMFix) == "OK":
            solver = getSolver(solveCaseFix)
            if solver != "":
                saveDir = os.getcwd()
                os.chdir(solveCaseFix)
                cont = "#!/ban/bash\n"
                cont = cont + ". " + envOpenFOAMFix + "\n"
                cont = cont + 'echo -n "running plotWatcher"\n'
                cont = cont + "pyFoamPlotWatcher.py solve.log 1> /dev/null 2> /dev/null\n"
                f = open("plotWatcher", "w")
                f.write(cont)
                f.close()
                os.system("chmod a+x plotWatcher")
                title = solveCaseFix
                if len(title) > 30:
                    title = "_..." + title[-30:]
                title = "plotWatcher:" + title
                comm = "gnome-terminal -t " + title + " --geometry=80x0 --hide-menubar -x bash --rcfile plotWatcher"
                os.system(comm)
                os.chdir(saveDir)
            else:
                title = "エラー"
                message = "「controlDict」は、存在しません。\n"
                message = message + "case directory が間違っています。"
                self.errDialog(title, message)
        else:
            title = "エラー"
            message = "環境設定file「bashrcFOAM」が存在しない為、FOAM端末が起動できません。\n"
            message = message + "　　configTreeFoamファイルの内容を確認してください。"
            self.errDialog(title, message)


    def runFoamTerm(self):
        item = self.tree_ctrl_1.GetSelection()
        directory = self.getDirectory(item)
        self.runFoamTermDir(directory)

    def runFoamTermDir(self, directory):
        global envOpenFOAMFix
        if self.checkApp(directory, envOpenFOAMFix) == "OK":
            caseName = directory.split("/")[-1]
            comm = "cd " + directory + "; gnome-terminal -t " + caseName + " -x bash --rcfile " + envOpenFOAMFix + " &"
            os.system(comm)
        else:
            title = "エラー"
            message = "「" + envOpenFOAMFix + "」は、存在しません。\n"
            message = message + "FOAM端末の環境設定fileが間違っています。\n"
            message = message + "  configFoamTreeの内容を確認してください。"
            self.errDialog(title, message)

    def checkApp(self, directory, App):
        flag = "NG"
        names = glob.glob(directory + "/" + App)
        if len(names) == 1:
            flag = "OK"
        else:
            names = glob.glob(App)
            if len(names) == 1:
                flag = "OK"
            else:
                paths = os.environ["PATH"].split(":")
                for path in paths:
                    names = glob.glob(path + "/" + App)
                    if len(names) == 1:
                        flag = "OK"
                        break
        return flag

    def runParaFoamDir(self, directory):
        global paraFoamFix
        if checkFolder(directory) == "case":
            if self.checkApp(directory, paraFoamFix) == "OK":
                comm = "cd " + directory + ";" + paraFoamFix + "&"
                os.system(comm.encode("utf-8"))
            else:
                title = "エラー"
                message = "「" + paraFoamFix + "」は、存在しません。\n"
                message = message + "実行fileが間違っています。"
                self.errDialog(title, message)
        else:
            title = u"エラー"
            message = u"指定されたフォルダ「" + directory + u"」は、OpenFOAMのCaseではありません。"
            self.errDialog(title, message)

    def runSalomeMeca(self, directory):
        global salomeMecaFix
        if self.checkApp(directory, salomeMecaFix) == "OK":
            comm = salomeMecaFix + " " + directory
            #comm = "cd " + directory + ";" + salomeMecaFix
            os.system(comm.encode("utf-8"))
        else:
            title = "エラー"
            message = "「" + salomeMecaFix + "」は、存在しません。\n"
            message = message + "実行fileが間違っています。"
            self.errDialog(title, message)

    def runCAD(self, directory):
        global cadFix
        if self.checkApp(directory, cadFix) == "OK":
            comm = "cd " + directory + ";" + cadFix + " &"
            os.system(comm)
        else:
            title = "エラー"
            message = "「" + cadFix + "」は、存在しません。\n"
            message = message + "実行fileが間違っています。"
            self.errDialog(title, message)


    #---------config------------------------
    #
    # getConfig
    #
    def getConfig(self):
        global rootDirFix, selCaseDirFix
        global rootDir, selCaseDir, configFile

        rootDir = rootDirFix
        selCaseDir = selCaseDirFix

        message = ""
        if rootDir == "":
            rootDir = os.path.expanduser("~")
            rootDirFix = rootDir
            message = message + "rootDirが設定されていません。rootDirとしてhomeDirを設定しました。\n"
        if selCaseDir == "":
            selCaseDir = rootDir
            selCaseDirFix = selCaseDir
            message = message + "selCaseDirが設定されていません。selCaseDirとしてrootDirを設定しました。\n"
        if message != "":
            title = "エラー"
            self.errDialog(title, message)

    def saveRootDirToConfig(self, dirName):
        global rootDirFix
        rootDirFix = dirName

    def saveSelCaseDirToConfig(self, dirName):
        global selCaseDirFix
        selCaseDirFix = dirName


    #
    #  readConfig
    #    configFileの読み込み
    def readConfig(self):
        global rootDirFix, solveCaseFix, selCaseDirFix, configFile, paraFoamFix, treeFoamPath, salomeMecaFix, envOpenFOAMFix, cadFix
        os.chdir(treeFoamPath)
        f = open(configFile)
        configContents = f.readlines()
        f.close()
        for line in configContents:
            word = line.split()
            if (len(word) > 0):
                if (word[0] == "rootDir"):
                    if len(word) >1:
                        rootDirFix = word[1]
                    else:
                        rootDirFix = ""
                if (word[0] == "workDir"):
                    if len(word) >1:
                        solveCaseFix = word[1]
                        selCaseDirFix = solveCaseFix
                    else:
                        solveCaseFix = ""
                        selCaseDirFix = solveCaseFix
                if (word[0] == "paraFoam"):
                    if len(word) >1:
                        paraFoamFix = word[1]
                    else:
                        paraFoamFix = ""
                if (word[0] == "salomeMeca"):
                    if len(word) >1:
                        salomeMecaFix = word[1]
                    else:
                        salomeMecaFix = ""
                if (word[0] == "bashrcFOAM"):
                    if len(word) >1:
                        envOpenFOAMFix = word[1]
                    else:
                        envOpenFOAMFix = ""
                if (word[0] == "CAD"):
                    if len(word) >1:
                        cadFix = word[1]
                    else:
                        cadFix = ""


    #
    #  writeConfig
    #    configFileの書き込み
    def writeConfig(self):
        global rootDirFix, solveCaseFix, selCaseDirFix, configFile, treeFoamPath
        os.chdir(treeFoamPath)
        f= codecs.open(configFile, "r", "utf-8")
        configContents = f.readlines()
        f.close()

        #rootDirの置き換え
        i=0
        flag = 0
        for line in configContents:
            word = line.split()
            if (len(word) > 0):
                if (word[0] == "rootDir"):
                    if type(rootDirFix) == str:
                        rootDirFix = rootDirFix.decode("utf-8")
                    configContents[i] = word[0] + "   " + rootDirFix + "\n"
                    flag = 1
                    break
            i=i+1
        if flag == 0:
            configContents.append("rootDir   " + rootDirFix + "\n")

        #solveCaseの置き換え
        i=0
        flag = 0
        for line in configContents:
            word = line.split()
            if (len(word) > 0):
                if (word[0] == "workDir"):
                    if type(solveCaseFix) == str:
                        solveCaseFix = solveCaseFix.decode("utf-8")
                    configContents[i] = word[0] + "   " + solveCaseFix + "\n"
                    flag = 1
                    break
            i=i+1
        if flag == 0:
            configContents.append("workDir   " + solveCaseFix + "\n")

        #ファイルに書込
        fu = codecs.open(configFile, "w", "utf-8")
        for line in configContents:
            fu.write(line)
        fu.close()


    #----------universal dialog-------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        if ans == wx.ID_OK:
            dlg.Destroy()
            return "OK"
        else:
            dlg.Destroy()
            return "CANCEL"

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def warningDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_QUESTION) 
        dlg.ShowModal()
        dlg.Destroy()

    def textDialog(self, title, message, defText):
        dlg = wx.TextEntryDialog(self, message, title, defaultValue=defText)
        ansBtn = dlg.ShowModal()
        ansTxt = dlg.GetValue()
        if ansBtn == wx.ID_OK:
            text = ansTxt
        else:
            text = ""
        return text

    def writeStatus(self, text):
        self.frame_1_statusbar.SetStatusText(text)

    def clearStatus(self):
        self.frame_1_statusbar.SetStatusText("")

# end of class MyFrame


#
# getBashrcFoam
#   外からOpenFOAMの環境設定ファイルを読み込む時に使用
#   環境変数$TreeFoamPathから取得する
def getBashrcFoam():
    treeFoamPath = os.environ["TreeFoamPath"]
    if treeFoamPath == "":
        print "環境変数$TreeFoamPathが設定されていないので、隠しファイル~/.treeFoamInstallFolderから、TreeFoamPathを取得します。"
        homeFolder = os.environ["HOME"]
        f = open(homeFolder + "/.treeFoamInstallFolder")
        treeFoamPath = f.readline()
        f.close()
    f = open(treeFoamPath + "/configTreeFoam")
    configContents = f.readlines()
    f.close()
    for line in configContents:
        word = line.split()
        if (len(word) > 0):
            if (word[0] == "bashrcFOAM"):
                if len(word) >1:
                    envOpenFOAMFix = word[1]
                else:
                    envOpenFOAMFix = ""
                break
    return envOpenFOAMFix


def getSolver(selectDir):
    fileName = selectDir + "/system/controlDict"
    solver = ""
    if os.path.isfile(fileName) == True:
        f=open(fileName)
        for line in f.readlines():
            lineList = line.split()
            if len(lineList) >= 2:
                if lineList[0] == "application":
                    solver = lineList[1]
                    if solver[-1] == ";":
                        solver = solver[:-1]
                    break
        f.close()
    return solver

    

#
#  getResultTimeFolders
#    計算結果フォルダを取得
def getResultTimeFolders(wdir):
    folders = getFoldersOnlyCurrDir(wdir)
    ans = []
    for folder in folders:
        a = folder.split("/")[-1]
        try:
            num = float(a)
            ans.append([num,a])
        except:
            a = ""
    ans.sort()
    timeFolders = []
    for a in ans:
        timeFolders.append(a[1])
    return timeFolders

#
#  getNumberResult
#    計算結果folderの数を取得
def getNumberResult(selectDir):
    folders = getFoldersOnlyCurrDir(selectDir)
    ans = []
    for folder in folders:
        try:
            a = float(folder.split("/")[-1])
            ans.append(a)
        except:
            a = 1.0
    nRst = len(ans)
    if nRst < 2:
        for folder in folders:
            if folder.split("/")[-1] == "processor0":
                subFolders = getFoldersOnlyCurrDir(selectDir + "/processor0")
                ans = []
                for subFolder in subFolders:
                    try:
                        a = float(subFolder.split("/")[-1])
                        ans.append(a)
                    except:
                        a = 1.0
                nRst = len(ans)
                break
    ansR = []
    if nRst != 0:
        ansR.append(" " + str(nRst))
        ansR.append(" " + str(min(ans)))
        if min(ans) == max(ans):
            ansR.append("")
        else:
            ansR.append(" " + str(max(ans)))

    """
    ansR.append(" " + str(nRst))
    ansR.append(" " + str(min(ans)))
    if min(ans) == max(ans):
        ansR.append("")
    else:
        ansR.append(" " + str(max(ans)))
    """
    return ansR

#
#  checkFolder
#    folderのチェック
def checkFolder(folderDir):
    ans = ""
    if os.path.isdir(folderDir) == True:
        ans = "folder"
        folderName = folderDir.split("/")[-1]
        try:
            a=float(folderName)
            #数字フォルダ
            ans = "hide"
        except:
            if (folderName == "system" or
            folderName == "constant" or
            folderName == "model" or
            folderName == "solve.log.analyzed" or
            folderName[0] == "."):
                #禁止フォルダ
                ans = "hide"
            else:
                controlDict = folderDir + "/system/controlDict"
                if os.path.isfile(controlDict)==True:
                    #caseフォルダ
                    ans = "case"
    else:
        #ファイル
        ans = "file"
    return ans

#
#  setEditFolders
#    編集するtimeフォルダ内のファイルとフォルダをセット
def setEditFolders(editDir):
    FFlist = []
    allFiles = getFoldersFiles(editDir)
    # カレントフォルダをFFlistにセット
    folderFiles = setFolderFiles(".",allFiles[1])
    FFlist.append(folderFiles)
    # フォルダをFFlistにセット
    folders = allFiles[0]
    i = 0
    while i < len(folders):
        # 各フォルダをFFlistにセット
        wdir = editDir + "/" + folders[i]
        allFiles = getFoldersFiles(wdir)
        folderFiles = setFolderFiles(folders[i],allFiles[1])
        FFlist.append(folderFiles)
        i = i + 1
    return FFlist

def setFolderFiles(folder, files):
    FFlist = []
    FFlist.append(folder)
    for name in files:
        if name[-1] != "~":
            FFlist.append(name)
    return FFlist

def getFoldersFiles(wdir):      #wdirは、絶対path
    allItems = os.listdir(wdir)
    files = []; folders = []
    for item in allItems:
        newItem = wdir + "/" + item
        if os.path.isdir(newItem) == True:
            folders.append(item)
        else:
            files.append(item)
    folders.sort()
    files.sort()
    ans = []
    ans.append(folders)
    ans.append(files)
    return ans

#
#  getTreeDirOnlylRootChildren
#
def getTreeDirOnlylRootChildren(rootDir):
    global treeData, selCase
    folderDir = []
    currDir = rootDir
    #rootのフォルダ取得
    folders = getFoldersOnlyCurrDir(rootDir)
    for folder in folders:
        folderDir.append(folder)
    #treeデータ作成
    folderDir.sort()
    i=0
    rootName = "root"
    treeData = [rootName,[]]
    while (i<len(folderDir)):
        folderDir[i] = rootName + folderDir[i][len(rootDir):]
        folderDir[i] = folderDir[i].split("/")
        i=i+1
    folderDir = checkTreeData(folderDir)
    for folder in folderDir:
        setTreeDataFolder(0, treeData, folder)
    treeData[0] = rootDir

#
#  getTreeDirUntilCurrCase
#    currCaseまでのtreeデータ取得
#
def getTreeDirUntilCurrCase(rootDir, selCaseDir):
    global treeData, selCase
    folderDir = []
    currDir = rootDir
    #rootのフォルダ取得
    folders = getFoldersOnlyCurrDir(rootDir)
    if len(folders) == 0:
        print "rootDirがありません。\n　homeDirをrootDirに設定しました。"
        rootDir = os.environ["HOME"]
        currDir = rootDir
        folders = getFoldersOnlyCurrDir(rootDir)
    for folder in folders:
        folderDir.append(folder)
        subFolders = getFoldersOnlyCurrDir(folder)
        for subFolder in subFolders:
            folderDir.append(subFolder)
    #selCase系列のフォルダ取得
    selCaseNames = selCaseDir[len(rootDir)+1:].split("/")
    for name in selCaseNames:
        currDir = currDir + "/" + name
        folders = getFoldersOnlyCurrDir(currDir)
        for folder in folders:
#            folderDir.append(folder)
            subFolders = getFoldersOnlyCurrDir(folder)
            for subFolder in subFolders:
                folderDir.append(subFolder)
    #selCaseの設定
    selCase=[]
    selCase.append(rootDir)
    for name in selCaseNames:
        selCase.append(name)
    #treeデータ作成
    folderDir.sort()
    i=0
    rootName = "root"
    treeData = [rootName,[]]
    while (i<len(folderDir)):
        folderDir[i] = rootName + folderDir[i][len(rootDir):]
        folderDir[i] = folderDir[i].split("/")
        i=i+1
    folderDir = checkTreeData(folderDir)
    for folder in folderDir:
        setTreeDataFolder(0, treeData, folder)
    treeData[0] = rootDir
    


#
#　getFoldersOnlyCurrDir
#  　currDirのみのFolderを取得する
#
def getFoldersOnlyCurrDir(currDir):
    folders = []
    try:
        allItem = os.listdir(currDir)
        for item in allItem:
            newFolder = currDir + "/" + item
            if os.path.isdir(newFolder) == True:
                folders.append(newFolder)
    except:
        folders=[]
    return folders


#
#  禁止folderを削除
#   数字、system、constant、model、solve.log.analyzed、OpenFOAM
#   隠しフォルダ
def checkTreeData(folderDir):
    ans = []
    for directory in folderDir:
        flag = 0
        for folder in directory:
            try:
                a=float(folder)
                flag = 1
                break
            except:
                a=folder

            if folder == "":
                flag = 1
            else:
                if (folder == "system" or
                  folder == "constant" or
                  folder == "model" or
                  folder == "solve.log.analyzed" or
                  folder[0] == "."):
                    flag = 1
                    break
        if flag == 0:
            ans.append(directory)
    return ans

            

def setTreeDataFolder(nest,tree, folder):
    nest = nest + 1
    if nest > 50:
        print "フォルダのネスティングが深すぎます。"
        return
    #親folderまでskipする。
    parentDir = folder[nest]
    ii=0
    while ii<len(tree[1]):
        if type(tree[1][ii]) == list:
            if tree[1][ii][0] == parentDir:
                setTreeDataFolder(nest, tree[1][ii], folder)
                break
        else:
            if tree[1][ii] == parentDir:
                tree[1][ii] = [parentDir, []]
                setTreeDataFolder(nest, tree[1][ii], folder)
                break
        ii=ii+1
    #親folderの位置ならchildを追加する。
    if nest == len(folder)-1:
        parent = folder[-2]
        child = folder[-1]
        tree[1].append(child)



#
#  endingTreeFoam
#    TreeFoamの終了処理
def endingTreeFoam():
    # TreeFoamの起動番号（nTreeFoam）を削除
    fileName = treeFoamPath + "/nRunningTreeFoam"
    f=open(fileName); contents=f.readlines(); f.close()
    newNoList = []
    for line in contents:
        NoList=line.split()
        if len(NoList) != 0:
            No = int(NoList[0])
            if No != int(nTreeFoam):
                newNoList.append(line)
    f=open(fileName,"w")
    for line in newNoList:
        f.write(line)
    f.close()

#  getTreeFoamInstallDir
#    treeFoamのインストールdirを取得
def getTreeFoamInstallDir():
    homeFolder = os.path.expanduser("~")
    fileName = homeFolder + "/.treeFoamInstallFolder"
    f=open(fileName); treeFoamDir=f.readline(); f.close()
    return treeFoamDir

# initializeTreeFoam
#   初期化
def initializeTreeFoam():
    global treeFoamPath, nTreeFoam, version
    #treeFoamのインストールフォルダの取得、隠しファイル作成
    treeFoamPath = os.getcwd()
    homeFolder = os.path.expanduser("~")
    fileName = homeFolder + "/.treeFoamInstallFolder"
    f=open(fileName, "w")
    f.write(treeFoamPath)
    f.close()
    #TreeFoamの起動No取得
    fileName = treeFoamPath + "/nRunningTreeFoam"
    f=open(fileName); contents = f.readlines(); f.close()
    No = -1
    for line in contents:
        NoList = line.split()
        if len(NoList) != 0:
            No = int(NoList[0])
    nTreeFoam = str(No + 1)
    contents.append(nTreeFoam + "\n")
    f=open(fileName,"w")
    for line in contents:
        f.write(line)
    f.close()
    #TeeFoamのバージョンを記録
    delFileName = treeFoamPath + "/Ver_*"
    command = "rm " + delFileName
    os.system(command)
    fileName = treeFoamPath + "/Ver_" + version
    f=open(fileName, "w"); f.close()
    print "TreeFoam ver", version, " (" + nTreeFoam + ") を起動しました。"


if __name__ == "__main__":
    #treeFoamPath = os.getcwd()
    initializeTreeFoam()
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()

